#include <windows.h>
#include <gl/gl.h>
#include <gl/glaux.h>
#include <gl/glu.h>
#include <math.h>
#include <cstringt.h>
#include <cstringt.h>
#include <atlstr.h>
#include <stdio.h>
#include <time.h>
#include <stdarg.h>
#include <Windowsx.h>
#include <olectl.h>
#include "textures.h"
#include <mmsystem.h>
#include <memory.h>
#include <vector>
#include "helpers.h"
//#include "sound.h"
void ef_pre_set()
{
	glPushAttrib(GL_ALL_ATTRIB_BITS);
	glEnable(GL_TEXTURE_2D);
	glEnable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE);
	glEnable(GL_DEPTH_TEST);
	glDepthMask(GL_FALSE);
}
void ef_re_store()
{
	glPopAttrib();

}
class sprite_effect
{
public:
	int count_frames;
	TGA_texture *images[128];
	sprite_effect();
	//   
	void load_images(char *filename);
	~sprite_effect();
};
sprite_effect::~sprite_effect()
{
	int a;
	if(count_frames>0)
	{
		for(a=0;a<count_frames;a++)
		{
			delete(images[a]);
		}
	}
}
sprite_effect::sprite_effect()
{
	count_frames=0;
}
void sprite_effect::load_images(char *filename)
{
	char *buf;
	char buf2[1000];
	sprintf(buf2,"%s",filename);
	char st[]=" ,\t\n";

	if(buf=strtok(buf2,st))
	{
		images[count_frames]=new TGA_texture();
		images[count_frames]->LoadTGA(buf);
		count_frames++;
		while(buf=strtok(NULL,st))
		{
			images[count_frames]=new TGA_texture();
			images[count_frames]->LoadTGA(buf);
			count_frames++;
		}
	}
}

//--------------------------------------------------------

class instance
{
public:
	float frame;
	float speed;
	int num_effect;
	float X,Y,Z;
	float aX,aY,aZ;
	float width,height;
	bool loop;
	instance();
	~instance(){};
};
instance::instance()
{
	loop=false;
	X=Y=Z=aX=aY=aZ=0;
	width=height=0;
	num_effect=0;
	frame=0;
	speed=0.05;
}
class efFlat
{
	int count_effects;
	int count_instances;
public:

	instance *instances[512];
	sprite_effect *sprites[128];
	
	efFlat();
	~efFlat();

	void add_effect(char *filename);
	void add_instance(int num_effect,float width,float height,float x,float y, float z, float ax, float ay,float az,bool loop);
	bool draw_sprite_effect(int num_instance);
};
efFlat::~efFlat()
	{
		int a;
		for(a=0;a<count_instances;a++)
		{
			delete(instances[a]);
		}
		for(a=0;a<count_effects;a++)
		{
			delete(sprites[a]);
		}

	}
efFlat::efFlat()
{
	count_effects=0;
	count_instances=0;
}
void efFlat::add_effect(char *filename)
{
	
	sprites[count_effects]=new sprite_effect();
	sprites[count_effects]->load_images(filename);
	count_effects++;
}
void efFlat::add_instance(int num_effect,float width,float height,float x,float y, float z, float ax, float ay,float az,bool loop)
{
	instances[count_instances]=new instance();
	instances[count_instances]->X=x;
	instances[count_instances]->Y=y;
	instances[count_instances]->Z=z;
	instances[count_instances]->aX=ax;
	instances[count_instances]->aY=ay;
	instances[count_instances]->aZ=az;
	instances[count_instances]->num_effect;
	instances[count_instances]->loop=loop;
	instances[count_instances]->width=width;
	instances[count_instances]->height=height;
	count_instances++;
}
bool efFlat::draw_sprite_effect(int num_instance)
{
	if(instances[num_instance]->frame<sprites[instances[num_instance]->num_effect]->count_frames||instances[num_instance]->loop==true)
	{
		if(instances[num_instance]->frame>=sprites[instances[num_instance]->num_effect]->count_frames)
		{
			instances[num_instance]->frame=0;	
		}
		

		glTranslatef(instances[num_instance]->X,instances[num_instance]->Y,instances[num_instance]->Z);
		glRotatef(instances[num_instance]->aX,1,0,0);
		glRotatef(instances[num_instance]->aY,0,1,0);
		glRotatef(instances[num_instance]->aZ,0,0,1);
		glBindTexture(GL_TEXTURE_2D,sprites[instances[num_instance]->num_effect]->images[(int)instances[num_instance]->frame]->texID);
		glBegin(GL_POLYGON);
			glNormal3f(0,0,1);
			glTexCoord2f(0,0); glVertex3f(-instances[num_instance]->width/2,-instances[num_instance]->height/2,0);
			glTexCoord2f(1,0); glVertex3f(instances[num_instance]->width/2,-instances[num_instance]->height/2,0);
			glTexCoord2f(1,1); glVertex3f(instances[num_instance]->width/2,instances[num_instance]->height/2,0);
			glTexCoord2f(0,1); glVertex3f(-instances[num_instance]->width/2,instances[num_instance]->height/2,0);
		glEnd();
		glRotatef(-instances[num_instance]->aX,1,0,0);
		glRotatef(-instances[num_instance]->aY,0,1,0);
		glRotatef(-instances[num_instance]->aZ,0,0,1);
		glTranslatef(-instances[num_instance]->X,-instances[num_instance]->Y,-instances[num_instance]->Z);
		instances[num_instance]->frame+=instances[num_instance]->speed;	
		return true;
	}
	return false;
}
//####################################################################
//####################################################################
class inner_particle_instance
{
public:
	~inner_particle_instance(){};
	float X,Y,Z;
	float frame;
	inner_particle_instance()
	{
		X=Y=Z=0;
		frame=0;
	};
	void clear()
	{
		X=Y=Z=0;
		frame=0;
	}
};
void Draw_in(float width,inner_particle_instance *instance,sprite_effect*graphic)
{



	//     
	double ModelViewMatrix[16];
	glGetDoublev(GL_MODELVIEW_MATRIX, ModelViewMatrix);
	//     
	glBindTexture(GL_TEXTURE_2D,graphic->images[0]->texID);
	CVector3 Right((float)ModelViewMatrix[0], (float)ModelViewMatrix[4], (float)ModelViewMatrix[8]);
	CVector3 Up((float)ModelViewMatrix[1], (float)ModelViewMatrix[5], (float)ModelViewMatrix[9]);
	//    
	CVector3 Coo[4];
	Coo[0] = (-Right-Up)*width; Coo[1] = (Right-Up)*width;
	Coo[2] = (Right+Up)*width; Coo[3] = (-Right+Up)*width;

	//     -   

	//   
	glBegin(GL_QUADS);
	//        
		//   ,    
		glColor3f(1.0f, 1.0f, 1.0f);
		//        
		glTexCoord2f(1.0f,1.0f); 
		glVertex3f((Coo[0]).x+instance->X,(Coo[0]).y+instance->Y, (Coo[0]).z+instance->Z);
		glTexCoord2f(0.0f,1.0f); 
		glVertex3f((Coo[1]).x+instance->X,(Coo[1]).y+instance->Y, (Coo[1]).z+instance->Z);

		glTexCoord2f(0.0f,0.0f); 
		glVertex3f((Coo[2]).x+instance->X,(Coo[2]).y+instance->Y, (Coo[2]).z+instance->Z);

		glTexCoord2f(1.0f,0.0f); 
		glVertex3f((Coo[3]).x+instance->X,(Coo[3]).y+instance->Y, (Coo[3]).z+instance->Z);
//   
	glEnd();

}
class efParticle
{
public:
	float speed_draw;
	bool loop;
	bool alive;
	float life_time;
	int tail_length; 
	float aX,aY,aZ;
	float usX,usY,usZ;
	float spdX,spdY,spdZ;
	float width,height;
	sprite_effect *image;
	inner_particle_instance *instances[64];
	efParticle();
	efParticle(int length_tail,float X,float Y, float Z);

	void load_image(char *filename);
	void move_to(float X,float Y,float Z);
	void draw();
	void clear();
	void range_frames();
	~efParticle();

};
efParticle::~efParticle()
{
	int a;
	if (tail_length>0)delete(image);
	for(a=0;a<=tail_length;a++)
	{
		delete(instances[a]);
	}
}
efParticle::efParticle()
{
	loop=true;
	image=new sprite_effect();
	alive=true;
	life_time=0;
	aX=aY=aZ=0;
	width=1;
	height=1;
	speed_draw=0.01;
	usX=usY=usZ=0;
}
efParticle::efParticle(int length_tail,float X,float Y, float Z)
{
	int a;
	loop=1;
	image=new sprite_effect();
	alive=true;
	life_time=0;
	aX=aY=aZ=0;
	width=1;
	height=1;
	speed_draw=0.01;
	usX=usY=usZ=0;
	if(length_tail<64)
	{
		tail_length=length_tail;
		for(a=0;a<=tail_length;a++)
		{
			instances[a]=new inner_particle_instance;
			instances[a]->X=X;
			instances[a]->Y=Y;
			instances[a]->Z=Z;
		}
	
	}

}
void efParticle::load_image(char *filename)
{
	image= new sprite_effect();
	image->load_images(filename);
}
void efParticle::move_to(float X,float Y,float Z)
{
	int a;
	for(a=tail_length;a>0;a--)
	{
		instances[a]->X=instances[a-1]->X;
		instances[a]->Y=instances[a-1]->Y;
		instances[a]->Z=instances[a-1]->Z;
	}
	instances[0]->X=X;
	instances[0]->Y=Y;
	instances[0]->Z=Z;
	instances[a]->frame+=speed_draw;
	if(instances[a]->frame>image->count_frames&&loop==true) instances[a]->frame=0;
}
void efParticle::draw()
{
int a;
	float x,y,z;
	x=y=z=0;
	//___________________
	for(a=0;a<=tail_length;a++)
	{
		if(instances[a]->frame<image->count_frames||loop==true)
		{
			if(instances[a]->frame>=0)
			{
				Draw_in(width,instances[a],image);
				
			}
			
			
		}
	}
}
void efParticle::range_frames()
{
	int a;
	for(a=0;a<=tail_length;a++)
	{
		if(a<image->count_frames)
		{
			instances[a]->frame=a;
		}
		else
		{
			instances[a]->frame=-(a-image->count_frames);
		}
	}
}

void efParticle::clear()
{
	life_time=0;
	aX=aY=aZ=0;
	spdX=spdY=spdZ=0;
	int a;
	for(a=0;a<tail_length;a++)
	{
		instances[a]->clear();
	}
}
//##########################################################
//##########################################################
class efParticle_without_graphic
{
public:
	float speed_draw;
	float life_time;
	bool loop;
	bool alive;
	int tail_length; 
	float aX,aY,aZ;
	float spdX,spdY,spdZ;
	float usX,usY,usZ;
	float width,height;
	inner_particle_instance *instances[64];
	efParticle_without_graphic();
	efParticle_without_graphic(int length_tail,float X,float Y, float Z);
	void move_to(float X,float Y,float Z);
	void draw(sprite_effect*graphic);
	void range_frames(sprite_effect*graphic);
	void clear();
	//void Draw_in(float width,inner_particle_instance *instance,sprite_effect*graphic);
	~efParticle_without_graphic();

};
efParticle_without_graphic::~efParticle_without_graphic()
{
	int a;
	for(a=0;a<=tail_length;a++)
	{
		delete(instances[a]);
		
	}
}
void efParticle_without_graphic::clear()
{

	//alive=true;
	life_time=0;
	aX=aY=aZ=0;
	spdX=spdY=spdZ=usX=usY=usZ=0;
	int a;
	for(a=0;a<tail_length;a++)
	{
		instances[a]->clear();
	}
}
efParticle_without_graphic::efParticle_without_graphic()
{
	loop=1;
	alive=true;
	life_time=0;
	aX=aY=aZ=0;
	width=1;
	height=1;
	speed_draw=0.01;
	usX=usY=usZ=0;
}
efParticle_without_graphic::efParticle_without_graphic(int length_tail,float X,float Y, float Z)
{
	int a;
	life_time=0;
	alive=true;
	loop=1;
	width=1;
	height=1;
	aX=aY=aZ=0;
	speed_draw=0.01;
	if(length_tail<64)
	{
		tail_length=length_tail;
		for(a=0;a<=tail_length;a++)
		{
			instances[a]=new inner_particle_instance;
			instances[a]->X=X;
			instances[a]->Y=Y;
			instances[a]->Z=Z;
		}
	
	}
	usX=usY=usZ=0;

}
void efParticle_without_graphic::move_to(float X,float Y,float Z)
{
	int a;
	for(a=tail_length;a>0;a--)
	{
		instances[a]->X=instances[a-1]->X;
		instances[a]->Y=instances[a-1]->Y;
		instances[a]->Z=instances[a-1]->Z;
	}
	instances[0]->X=X;
	instances[0]->Y=Y;
	instances[0]->Z=Z;
}
void efParticle_without_graphic::draw(sprite_effect*graphic)
{
	int a;
	//___________________
	for(a=0;a<=tail_length;a++)
	{
		if(instances[a]->frame<graphic->count_frames||loop==true)
		{
			if(instances[a]->frame>=0&&((instances[a]->X+instances[a]->Y+instances[a]->Z)!=0))
			{
				Draw_in(width,instances[a],graphic);			
			}
			instances[a]->frame+=speed_draw;
			if(instances[a]->frame>graphic->count_frames) instances[a]->frame=0;
		}
	}
	//___________________


}


void efParticle_without_graphic::range_frames(sprite_effect*graphic)
{
	int a;
	spdX=spdY=spdZ=0;
	for(a=0;a<=tail_length;a++)
	{
		if(a<graphic->count_frames)
		{
			instances[a]->frame=a;
		}
		else
		{
			instances[a]->frame=-(a-graphic->count_frames);
		}
	}
}



//##########################################################
//# @@@    @   @@@@   @@@@@   @   @@@   @   @@@@           #
//# @  @  @ @  @   @    @     @  @   @  @   @              #
//# @@@   @ @  @@@@     @     @  @      @   @@@            #
//# @    @@@@@ @   @    @     @  @   @  @   @              #
//# @    @   @ @    @   @     @   @@@   @@@ @@@@           #
//##########################################################
//##########################################################
//# @@@   @@@@  @   @  @@@@  @@@@   @   @@@@@   @@@   @@@@ #
//#@   @  @     @@  @  @     @   @ @  @   @    @   @  @   @#
//#@      @@@   @ @ @  @@@   @@@   @  @   @    @   @  @@@  #
//#@  @@  @     @  @@  @     @  @ @@@@@@  @    @   @  @  @ #
//# @@@   @@@@  @   @  @@@@  @   @@    @  @     @@@   @   @#
//##########################################################
class efParticle_generator
{
	float ticker;
	int count_particles;
public:
	
	sprite_effect *image;
	efParticle_without_graphic *particles[512];
	
	float aX,aY,aZ,X,Y,Z;
	float width,height;
	float minXStartSpeed,maxXStartSpeed;
	float minYStartSpeed,maxYStartSpeed;
	float minZStartSpeed,maxZStartSpeed;
	float count_particles_per_time;
	float particle_life_time;
	float particle_animate_speed;
	float life_speed;
	float GForce;
	float Gforce_on_X;
	float Gforce_on_Y;
	float Gforce_on_Z;
	int tails;
	~efParticle_generator();
	efParticle_generator();
	void generate_particles();
	void move_particles();
	void draw();
	void clear();
};
efParticle_generator::~efParticle_generator()
{
	//if(image!=NULL)delete(image);
	image=NULL;
	int a;
	for (a=0;a<count_particles;a++)
	{	
		delete(particles[a]);
		particles[a]=NULL;
	}
}
efParticle_generator::efParticle_generator()
{
	particle_animate_speed=0.01;
	tails=2;
	width=0.1;
	height=0.1;
	image=new sprite_effect();
	count_particles=0;
	life_speed=0.2;
	int a;
	X=Y=Z=0;
	for(a=0;a<512;a++) particles[a]=NULL;
	aX=aZ=0;
	aY=90;
	ticker=0;
	minXStartSpeed=-0.5;
	maxXStartSpeed=0.5;
	minYStartSpeed=0.01;
	maxYStartSpeed=0.9;
	minZStartSpeed=-0.5;
	maxZStartSpeed=0.5;
	GForce=0.001;
	Gforce_on_X=0;
	Gforce_on_Y=-1;
	Gforce_on_Z=0;

	count_particles_per_time=0.02;
	particle_life_time=0.2;
}
void efParticle_generator::generate_particles()
{
	int a;
	float A,B,C,D;
	bool flag=false;
	int otzepol;
	a=0;
	
	float count,div;
	float count2,div2;

	ticker+=count_particles_per_time;
	for(ticker;ticker>=1;ticker--)
	{
		//=============================================
		//       
		for(a=0;a<512;a++)
		{
			
			if(ticker<1)
			{
				//ticker=0;
				break;
			}
			if(particles[a]!=NULL)
			{
			
				if(particles[a]->alive==false)
				{
					
					particles[a]->move_to(X,Y,Z);
					particles[a]->alive=true;
					     if(minXStartSpeed<0&&maxXStartSpeed>0)B=fabs(minXStartSpeed)+maxXStartSpeed;
					else if(minXStartSpeed>0&&maxXStartSpeed>0&&minXStartSpeed>minXStartSpeed)B=maxXStartSpeed-minXStartSpeed;
					else if(minXStartSpeed>0&&minXStartSpeed>0&&maxXStartSpeed>minXStartSpeed)B=minXStartSpeed-maxXStartSpeed;
					B=(int)(B*1000);
					if(B==0)B=1000;
					particles[a]->spdX=minXStartSpeed+(float)(rand()%(int)(B))/1000;
					//^^^^^^^^^^^^^^^^^^
					  if(minYStartSpeed<0&&maxYStartSpeed>0)B=fabs(minYStartSpeed)+maxYStartSpeed;
					else if(minYStartSpeed>0&&maxYStartSpeed>0&&minYStartSpeed>minYStartSpeed)B=maxYStartSpeed-minYStartSpeed;
					else if(minYStartSpeed>0&&minYStartSpeed>0&&maxYStartSpeed>minYStartSpeed)B=minYStartSpeed-maxYStartSpeed;
					B=(int)(B*1000);
					if(B==0)B=1000;
					particles[a]->spdY=minYStartSpeed+(float)(rand()%(int)(B))/1000;

					//^^^^^^^^^^^^^^^^^^^^^^^^
					  if(minZStartSpeed<0&&maxZStartSpeed>0)B=fabs(minZStartSpeed)+maxZStartSpeed;
					else if(minZStartSpeed>0&&maxZStartSpeed>0&&minZStartSpeed>minZStartSpeed)B=maxZStartSpeed-minZStartSpeed;
					else if(minZStartSpeed>0&&minZStartSpeed>0&&maxZStartSpeed>minZStartSpeed)B=minZStartSpeed-maxZStartSpeed;
					B=(int)(B*1000);
					if(B==0)B=1000;
					particles[a]->spdZ=minZStartSpeed+(float)(rand()%(int)(B))/1000;
					break;
				}
			}
			else
			{
				
					particles[a]= new efParticle_without_graphic(tails,X,Y,Z);
					particles[a]->speed_draw=particle_animate_speed;
					particles[a]->range_frames(image);
					particles[a]->alive=true;
					     if(minXStartSpeed<0&&maxXStartSpeed>0)B=fabs(minXStartSpeed)+maxXStartSpeed;
					else if(minXStartSpeed>0&&maxXStartSpeed>0&&minXStartSpeed>minXStartSpeed)B=maxXStartSpeed-minXStartSpeed;
					else if(minXStartSpeed>0&&minXStartSpeed>0&&maxXStartSpeed>minXStartSpeed)B=minXStartSpeed-maxXStartSpeed;
					B=(int)(B*1000);
					if(B==0)B=1000;
					particles[a]->spdX=(minXStartSpeed+rand()%(int)(B))/1000;
						 if(minYStartSpeed<0&&maxYStartSpeed>0)B=fabs(minXStartSpeed)+maxYStartSpeed;
					else if(minYStartSpeed>0&&maxYStartSpeed>0&&minYStartSpeed>minYStartSpeed)B=maxYStartSpeed-minYStartSpeed;
					else if(minYStartSpeed>0&&minYStartSpeed>0&&maxYStartSpeed>minYStartSpeed)B=minYStartSpeed-maxYStartSpeed;
					B=(int)B;
					if(B==0)B=1;
					particles[a]->spdY=(minYStartSpeed+rand()%(int)(B*1000))/1000;
						 if(minZStartSpeed<0&&maxZStartSpeed>0)B=fabs(minZStartSpeed)+maxZStartSpeed;
					else if(minZStartSpeed>0&&maxZStartSpeed>0&&minZStartSpeed>minZStartSpeed)B=maxZStartSpeed-minZStartSpeed;
					else if(minZStartSpeed>0&&minZStartSpeed>0&&maxZStartSpeed>minZStartSpeed)B=minZStartSpeed-maxZStartSpeed;
					B=(int)B;
					if(B==0)B=1;
					particles[a]->spdZ=(minZStartSpeed+rand()%(int)(B*1000))/1000;

					     if(minXStartSpeed<0&&maxXStartSpeed>0)B=fabs(minXStartSpeed)+maxXStartSpeed;
					else if(minXStartSpeed>0&&maxXStartSpeed>0&&minXStartSpeed>minXStartSpeed)B=maxXStartSpeed-minXStartSpeed;
					else if(minXStartSpeed>0&&minXStartSpeed>0&&maxXStartSpeed>minXStartSpeed)B=minXStartSpeed-maxXStartSpeed;
					B=(int)(B*1000);
					if(B==0)B=1000;
					particles[a]->spdX=minXStartSpeed+(float)(rand()%(int)(B))/1000;
					//^^^^^^^^^^^^^^^^^^
					  if(minYStartSpeed<0&&maxYStartSpeed>0)B=fabs(minYStartSpeed)+maxYStartSpeed;
					else if(minYStartSpeed>0&&maxYStartSpeed>0&&minYStartSpeed>minYStartSpeed)B=maxYStartSpeed-minYStartSpeed;
					else if(minYStartSpeed>0&&minYStartSpeed>0&&maxYStartSpeed>minYStartSpeed)B=minYStartSpeed-maxYStartSpeed;
					B=(int)(B*1000);
					if(B==0)B=1000;
					particles[a]->spdY=minYStartSpeed+(float)(rand()%(int)(B))/1000;
					//^^^^^^^^^^^^^^^^^^^^^^^^
					  if(minZStartSpeed<0&&maxZStartSpeed>0)B=fabs(minZStartSpeed)+maxZStartSpeed;
					else if(minZStartSpeed>0&&maxZStartSpeed>0&&minZStartSpeed>minZStartSpeed)B=maxZStartSpeed-minZStartSpeed;
					else if(minZStartSpeed>0&&minZStartSpeed>0&&maxZStartSpeed>minZStartSpeed)B=minZStartSpeed-maxZStartSpeed;
					B=(int)(B*1000);
					if(B==0)B=1000;
					particles[a]->spdZ=minZStartSpeed+(float)(rand()%(int)(B))/1000;
					break;
			}
		}
		//==============================================
	}


	
}

void efParticle_generator::move_particles()
{
	int a;
	 for(a=0;a<512;a++)
	 {
	    if(particles[a])
		{
			if(particles[a]->alive==true)
			{
				particles[a]->life_time+=life_speed;
				if(particles[a]->life_time<=particle_life_time)
				{
					particles[a]->usX+=GForce*Gforce_on_X;
					particles[a]->usY+=GForce*Gforce_on_Y;
					particles[a]->usZ+=GForce*Gforce_on_Z;
					particles[a]->spdX+=particles[a]->usX;
					particles[a]->spdY+=particles[a]->usY;
					particles[a]->spdZ+=particles[a]->usZ;
					particles[a]->move_to(particles[a]->instances[0]->X+particles[a]->spdX,particles[a]->instances[0]->Y+particles[a]->spdY,particles[a]->instances[0]->Z+particles[a]->spdZ);
				}
				else 
				{
					particles[a]->alive=false;
					particles[a]->life_time=0;
					particles[a]->clear();
					particles[a]->move_to(X,Y,Z);
				}
			}
			
		}

	 }
}
void efParticle_generator::draw()
{
	int a,b;
	for(a=0;a<512;a++)
	{
		if(particles[a])
		{
			if(particles[a]->alive==true)
			{
				particles[a]->width=width;
				particles[a]->height=height;
				particles[a]->draw(image);

			}
		}
	}
}

void efParticle_generator::clear()
{
	int a;
	for(a=0;a<512;a++)
	{
		if(particles[a])
		{
			particles[a]->alive=false;
			particles[a]->clear();
		}
	}
}
//########################################################
//########################################################
//##  $$   $    $   $$   $  $  $      $    $    $       ##
//## $  $  $$   $  $  $  $  $  $     $  $  $  $   $     ##
//## $     $ $  $  $  $  $  $  $      $   $$$    $      ##
//##  $$   $  $ $  $  $  $  $  $    $$$$$$$$$$$$$$$$    ##
//##    $  $   $$  $  $   $$$$$       $   $$$    $      ##
//## $  $  $    $  $  $   $   $      $  $  $  $   $     ##
//##  $$   $    $   $$    $   $       $    $    $       ##
//########################################################
//########################################################
class efSnow
{
	float ticker;
	int count_particles;
public:
	
	sprite_effect *image;
	efParticle_without_graphic *particles[512];
	
	float aX,aY,aZ,X,Y,Z;
	float radX,radY,radZ;
	float minXStartSpeed,maxXStartSpeed;
	float minYStartSpeed,maxYStartSpeed;
	float minZStartSpeed,maxZStartSpeed;
	float count_particles_per_time;
	float particle_life_time;
	float life_speed;
	float GForce;
	float Gforce_on_X;
	float Gforce_on_Y;
	float Gforce_on_Z;
	int tails;

	efSnow();
	~efSnow();
	void generate_particles();
	void move_particles();
	void draw();
};
efSnow::~efSnow()
{
	delete(image);
	int a;
	for(a=0;a<count_particles;a++)
	{
		delete(particles[a]);
	}
}
efSnow::efSnow()
{
	tails=2;
	image=new sprite_effect();
	count_particles=0;
	life_speed=0.2;
	int a;
	X=Y=Z=0;
	for(a=0;a<512;a++) particles[a]=NULL;
	aX=aZ=0;
	aY=90;
	radY=1;
	radX=10;
	radZ=10;
	ticker=0;
	minXStartSpeed=-0.5;
	maxXStartSpeed=0.5;
	minYStartSpeed=-0.01;
	maxYStartSpeed=-0.9;
	minZStartSpeed=-0.01;
	maxZStartSpeed=0.01;
	GForce=0.1;
	Gforce_on_X=0;
	Gforce_on_Y=-1;
	Gforce_on_Z=0;

	count_particles_per_time=0.02;
	particle_life_time=0.2;
}
void efSnow::generate_particles()
{
	int a;
	float A,B,C,D;
	bool flag=false;
	int otzepol;
	a=0;
	
	float count,div;
	float count2,div2;

	ticker+=count_particles_per_time;
	if(ticker>0)
	{
		//=============================================
		//       
		for(a=0;a<512;a++)
		{
			
			if(ticker<1)
			{
				//ticker=0;
				break;
			}
			if(particles[a]!=NULL)
			{
			
				if(particles[a]->alive==false)
				{
					ticker--;
					if((int)(radX*2*1000)==0)radX=0.01;
					if((int)(radY*2*1000)==0)radY=0.01;
					if((int)(radZ*2*1000)==0)radZ=0.01;


					A=(rand()%((int)(radX*1000)))/1000;
					D=rand()%100;
					if(D>=50)A=-A;
					A+=X;
					B=(rand()%((int)(radY*1000)))/1000;
					D=rand()%100;
					if(D>=50)B=-B;
					B+=Y;
					C=(rand()%((int)(radZ*1000)))/1000;
					D=rand()%100;
					if(D>=50)C=-C;
					C+=Z;
					particles[a]->move_to(A,B,C);
					particles[a]->alive=true;
					     if(minXStartSpeed<0&&maxXStartSpeed>0)B=fabs(minXStartSpeed)+maxXStartSpeed;
					else if(minXStartSpeed>0&&maxXStartSpeed>0&&minXStartSpeed>minXStartSpeed)B=maxXStartSpeed-minXStartSpeed;
					else if(minXStartSpeed>0&&minXStartSpeed>0&&maxXStartSpeed>minXStartSpeed)B=minXStartSpeed-maxXStartSpeed;
					else if(minXStartSpeed<0&&minXStartSpeed<0)B=minXStartSpeed-maxXStartSpeed;
					B=(int)(B*1000);
					if(B==0)B=1000;
					particles[a]->spdX=minXStartSpeed+(float)(rand()%(int)(B))/1000;
					//^^^^^^^^^^^^^^^^^^
					  if(minYStartSpeed<0&&maxYStartSpeed>0)B=fabs(minYStartSpeed)+maxYStartSpeed;
					else if(minYStartSpeed>0&&maxYStartSpeed>0&&minYStartSpeed>minYStartSpeed)B=maxYStartSpeed-minYStartSpeed;
					else if(minYStartSpeed>0&&minYStartSpeed>0&&maxYStartSpeed>minYStartSpeed)B=minYStartSpeed-maxYStartSpeed;
					B=(int)(B*1000);
					if(B==0)B=1000;
					particles[a]->spdY=minYStartSpeed+(float)(rand()%(int)(B))/1000;
					break;
					//^^^^^^^^^^^^^^^^^^^^^^^^
					  if(minZStartSpeed<0&&maxZStartSpeed>0)B=fabs(minZStartSpeed)+maxZStartSpeed;
					else if(minZStartSpeed>0&&maxZStartSpeed>0&&minZStartSpeed>minZStartSpeed)B=maxZStartSpeed-minZStartSpeed;
					else if(minZStartSpeed>0&&minZStartSpeed>0&&maxZStartSpeed>minZStartSpeed)B=minZStartSpeed-maxZStartSpeed;
					B=(int)(B*1000);
					if(B==0)B=1000;
					particles[a]->spdZ=minZStartSpeed+(float)(rand()%(int)(B))/1000;
					
				}
			}
			else
			{
				ticker--;
					if((int)(radX*1000)==0)radX=0.01;
					if((int)(radY*1000)==0)radY=0.01;
					if((int)(radZ*1000)==0)radZ=0.01;

					A=(rand()%((int)(radX*1000)))/1000;
					D=rand()%100;
					if(D>=50)A=-A;
					A+=X;
					B=(rand()%((int)(radY*1000)))/1000;
					D=rand()%100;
					if(D>=50)B=-B;
					B+=Y;
					C=(rand()%((int)(radZ*1000)))/1000;
					D=rand()%100;
					if(D>=50)C=-C;
					C+=Z;
					particles[a]= new efParticle_without_graphic(tails,A,B,C);
					particles[a]->range_frames(image);
					particles[a]->alive=true;
					     if(minXStartSpeed<0&&maxXStartSpeed>0)B=fabs(minXStartSpeed)+maxXStartSpeed;
					else if(minXStartSpeed>0&&maxXStartSpeed>0&&minXStartSpeed>minXStartSpeed)B=maxXStartSpeed-minXStartSpeed;
					else if(minXStartSpeed>0&&minXStartSpeed>0&&maxXStartSpeed>minXStartSpeed)B=minXStartSpeed-maxXStartSpeed;
					B=(int)(B*1000);
					if(B==0)B=1000;
					particles[a]->spdX=(minXStartSpeed+rand()%(int)(B))/1000;
						 if(minYStartSpeed<0&&maxYStartSpeed>0)B=fabs(minXStartSpeed)+maxYStartSpeed;
					else if(minYStartSpeed>0&&maxYStartSpeed>0&&minYStartSpeed>minYStartSpeed)B=maxYStartSpeed-minYStartSpeed;
					else if(minYStartSpeed>0&&minYStartSpeed>0&&maxYStartSpeed>minYStartSpeed)B=minYStartSpeed-maxYStartSpeed;
					B=(int)B;
					if(B==0)B=1;
					particles[a]->spdY=(minYStartSpeed+rand()%(int)(B*1000))/1000;
						 if(minZStartSpeed<0&&maxZStartSpeed>0)B=fabs(minZStartSpeed)+maxZStartSpeed;
					else if(minZStartSpeed>0&&maxZStartSpeed>0&&minZStartSpeed>minZStartSpeed)B=maxZStartSpeed-minZStartSpeed;
					else if(minZStartSpeed>0&&minZStartSpeed>0&&maxZStartSpeed>minZStartSpeed)B=minZStartSpeed-maxZStartSpeed;
					B=(int)B;
					if(B==0)B=1;
					particles[a]->spdZ=(minZStartSpeed+rand()%(int)(B*1000))/1000;

					     if(minXStartSpeed<0&&maxXStartSpeed>0)B=fabs(minXStartSpeed)+maxXStartSpeed;
					else if(minXStartSpeed>0&&maxXStartSpeed>0&&minXStartSpeed>minXStartSpeed)B=maxXStartSpeed-minXStartSpeed;
					else if(minXStartSpeed>0&&minXStartSpeed>0&&maxXStartSpeed>minXStartSpeed)B=minXStartSpeed-maxXStartSpeed;
					B=(int)(B*1000);
					if(B==0)B=1000;
					particles[a]->spdX=minXStartSpeed+(float)(rand()%(int)(B))/1000;
					//^^^^^^^^^^^^^^^^^^
					  if(minYStartSpeed<0&&maxYStartSpeed>0)B=fabs(minYStartSpeed)+maxYStartSpeed;
					else if(minYStartSpeed>0&&maxYStartSpeed>0&&minYStartSpeed>minYStartSpeed)B=maxYStartSpeed-minYStartSpeed;
					else if(minYStartSpeed>0&&minYStartSpeed>0&&maxYStartSpeed>minYStartSpeed)B=minYStartSpeed-maxYStartSpeed;
					B=(int)(B*1000);
					if(B==0)B=1000;
					particles[a]->spdY=minYStartSpeed+(float)(rand()%(int)(B))/1000;
					break;
					//^^^^^^^^^^^^^^^^^^^^^^^^
					  if(minZStartSpeed<0&&maxZStartSpeed>0)B=fabs(minZStartSpeed)+maxZStartSpeed;
					else if(minZStartSpeed>0&&maxZStartSpeed>0&&minZStartSpeed>minZStartSpeed)B=maxZStartSpeed-minZStartSpeed;
					else if(minZStartSpeed>0&&minZStartSpeed>0&&maxZStartSpeed>minZStartSpeed)B=minZStartSpeed-maxZStartSpeed;
					B=(int)(B*1000);
					if(B==0)B=1000;
					particles[a]->spdZ=minZStartSpeed+(float)(rand()%(int)(B))/1000;
					break;
				
			}
		}
		//==============================================
	}


	
}

void efSnow::move_particles()
{
	int a;
	 for(a=0;a<512;a++)
	 {
	    if(particles[a])
		{
			if(particles[a]->alive==true)
			{
				particles[a]->life_time+=life_speed;
				if(particles[a]->life_time<=particle_life_time)
				{
					particles[a]->spdX=GForce*Gforce_on_X;
					particles[a]->spdY=GForce*Gforce_on_Y;
					particles[a]->spdZ=GForce*Gforce_on_Z;
					particles[a]->move_to(particles[a]->instances[0]->X+particles[a]->spdX,particles[a]->instances[0]->Y+particles[a]->spdY,particles[a]->instances[0]->Z+particles[a]->spdZ);
				}
				else 
				{
					particles[a]->alive=false;
					particles[a]->life_time=0;
					particles[a]->clear();
					particles[a]->move_to(X,Y,Z);
				}
			}
			
		}

	 }
}
void efSnow::draw()
{
	int a,b;
	for(a=0;a<512;a++)
	{
		if(particles[a])
		{
			if(particles[a]->alive==true)
			{
				particles[a]->aX=aX;
				particles[a]->aY=aY;
				particles[a]->aZ=aZ;

				particles[a]->draw(image);

			}
		}
	}
}


//#########################################################
//#########################################################
//## @@@@  @    @  @@@   @    @@@   @@   @   @   @  @@@@ ##
//## @     @    @  @  @  @   @   @ @  @  @   @   @  @    ##
//## @@@    @  @   @  @  @   @   @ @     @   @   @  @@@  ##
//## @       @@    @@@   @   @   @  @@   @   @   @  @    ##
//## @      @  @   @     @   @   @    @  @    @ @   @    ##
//## @     @    @  @     @   @   @ @  @  @    @ @   @    ##
//## @@@@  @    @  @     @@@  @@    @@   @     @    @@@@ ##
//#########################################################
//#########################################################

class efExplosion
{
	
	float StartSmokeWidth;
	float StartSmokeHeight;
	float current_time;
public:
	bool enable;
	float X,Y,Z;
	float aX,aY,aZ;
	float SmokeWidth,SmokeHeight;
	float ParticleWidth,ParticleHeight;
	float ExplosionWidth,ExplosionHeight;
	//----------------------------------
	float count_particles_per_time;
	float count_smoke_per_time;
	float time_generating_particles;
	float time_generating_smoke;
	float lifetime;
	float speed_time;
	float SmokeSizingSpeed;
	//---------------------------------
	efParticle_generator *smoke;
	efParticle_generator *particles;
	efParticle *explosion;
	efExplosion();
	~efExplosion();
	void loadSmoke(char *filename);
	void loadParticles(char *filename);
	void loadExplosive(char *filename);
	void draw();
	void move();
	void run();
	void stop();
	void pregenerate(int steps);
};
efExplosion::~efExplosion()
{
	delete(smoke);
	smoke=NULL;
	delete(particles);
	particles=NULL;
	delete(explosion);
	explosion=NULL;
}

efExplosion::efExplosion()
{
	int a;
	enable=false;
	X=Y=Z=0;
	aX=aY=aZ=0;
	SmokeWidth=0.3;
	SmokeHeight=0.3;
	SmokeSizingSpeed=0.01;
	ParticleWidth=0.1;
	ParticleHeight=0.1;
	ExplosionWidth=1;
	ExplosionHeight=1;

	explosion=new efParticle(0,X,Y,Z);
	particles=new efParticle_generator();
	smoke=new efParticle_generator();
	
	//-----------------------------
	speed_time=0.1;
	count_particles_per_time=3;
	count_smoke_per_time=3;
	time_generating_particles=0.3;
	time_generating_smoke=0.9;	
	lifetime=10;
	//-----------------------------
	particles->GForce=0.0005;
	particles->tails=2;
	particles->particle_animate_speed=0;
	particles->minXStartSpeed=-0.05;
	particles->maxXStartSpeed=0.05;
	particles->minZStartSpeed=-0.05;
	particles->maxZStartSpeed=0.05;
	particles->minYStartSpeed=-0.1;
	particles->maxYStartSpeed=0.1;

	particles->life_speed=speed_time;
	particles->particle_life_time=lifetime;
	particles->width=ParticleWidth;
	particles->height=ParticleHeight;
	smoke->width=SmokeWidth;
	smoke->height=SmokeHeight;
	smoke->GForce=0;

	smoke->minXStartSpeed=-0.01;
	smoke->maxXStartSpeed=0.01;
	smoke->minYStartSpeed=0.01;
	smoke->maxYStartSpeed=0.05;
	smoke->minZStartSpeed=-0.01;
	smoke->maxZStartSpeed=0.01;
	smoke->life_speed=speed_time;
	smoke->particle_life_time=lifetime;
	smoke->count_particles_per_time=0.04;
	explosion->alive=true;
	explosion->loop=0;
	explosion->speed_draw=0.5;
	explosion->width=ExplosionWidth;
	explosion->height=ExplosionHeight;
	StartSmokeHeight=SmokeHeight;
	StartSmokeWidth=SmokeWidth;
}
void efExplosion::loadSmoke(char *filename)
{
	smoke->image->load_images(filename);
}
void efExplosion::loadParticles(char *filename)
{
	particles->image->load_images(filename);
}
void efExplosion::loadExplosive(char *filename)
{
	explosion->image->load_images(filename);
}
void efExplosion::run()
{
	explosion->instances[0]->frame=0;
	SmokeWidth=StartSmokeWidth;
	SmokeHeight=StartSmokeHeight;
	current_time=0;
	enable=true;
	smoke->clear();
	explosion->clear();
	particles->clear();

	explosion->move_to(X,Y,Z);
	particles->X=X;
	particles->Y=Y;
	particles->Z=Z;

	smoke->X=X;
	smoke->Y=Y;
	smoke->Z=Z;
	particles->count_particles_per_time=count_particles_per_time;
	smoke->count_particles_per_time=count_smoke_per_time;
	particles->clear();
	smoke->clear();
	explosion->width=ExplosionWidth;
	explosion->height=ExplosionHeight;
	particles->width=ParticleWidth;
	particles->height=ParticleHeight;
	
	
}
void efExplosion::move()
{
	if(enable==true)
	{
		particles->X=X;
		particles->Y=Y;
		particles->Z=Z;

		smoke->X=X;
		smoke->Y=Y;
		smoke->Z=Z;
		smoke->width=SmokeWidth;
		smoke->height=SmokeHeight;
		SmokeHeight+=SmokeSizingSpeed;
		SmokeWidth+=SmokeSizingSpeed;
		if(current_time<time_generating_particles)
		{
			particles->generate_particles();
		}
		if(current_time<time_generating_smoke)
		{
			smoke->generate_particles();
		}
		explosion->move_to(X,Y,Z);
		if(current_time<lifetime)
		{
			current_time+=speed_time;
		}
		else
		{
			current_time=0;
			enable=false;
		}
		particles->move_particles();
		smoke->move_particles();
	}
}
void efExplosion::draw()
{
	if(enable==true)
	{
		glEnable(GL_BLEND);
		glDepthMask(GL_FALSE);
		smoke->draw();
		ef_pre_set();
		particles->draw();
		explosion->draw();
		ef_re_store();
		glDepthMask(GL_TRUE);
		glDisable(GL_BLEND);

	}
}
void efExplosion::stop()
{
	enable=false;
}
void efExplosion::pregenerate(int steps)
{
	int a;
	run();
	for(a=0;a<steps;a++)
	{
		move();
		draw();
	}
	stop();
}
