#include <stdio.h>
#include <conio.h>
#include <time.h>
#include <math.h>
#include <stdlib.h>
#include "framerate.h"
#include "HKtools_pack.h"
#include "sound.h"
class Player
{
public:
	bool slow_active;
	bool stop_active;
	bool up_active;
	float slow_activity_time;
	float slow_max_activity_time;
	float stop_activity_time;
	float stop_max_activity_time;
	float up_activity_time;
	float up_max_activity_time;
	//------------------
	int stop;
	int slow;
	int up;
	int bomb_speeder;
	int count_bombs;
	int bomb_destruction;
	//------------------
	int points;
	int level;
	int phase;
	float x,y;
	int type_bomber;
	
	float fly_speed;
	float y_fly_speed;
	float bomb_speed;
	
	Player();
	void onstart();
	void clear();
	bool save(char *filename);
	bool load(char *filename);
	models *frames;
	int count_frames;
	float cur_frame;
	float anim_speed;
	void draw();
	void load_models(char *zonename);
	void unload_models();
};
void Player::unload_models()
{
	frames->unload();
}
void Player::load_models(char *zonename)
{
	FILE *fil;
	char buf[512];
	int a;
	sprintf(buf,"models\\%s\\bomber_frames.cfg",zonename);
	anim_speed=0.05;
	if(fil=fopen(buf,"rb"))
	{
		fscanf(fil,"%s",buf);
		count_frames=atoi(buf);
		for(a=1;a<=count_frames;a++)
		{
			sprintf(buf,"models\\%s\\bomber%d.md0b",zonename,a);
			frames->load_model_binary(buf);
		}
	}

	else
	{
		sprintf(buf,"models\\%s\\bomber.md0b",zonename);
		frames->load_model_binary(buf);
		count_frames=1;
	}
	anim_speed=0.45;
}
void Player::draw()
{
	glCallList(frames->model[(int)cur_frame]);
	cur_frame+=anim_speed;
	if(cur_frame>=count_frames)cur_frame=0;
}
void Player::clear()
{
	cur_frame=0;
	x=-3;
	y=0;
	type_bomber=1;
	count_bombs=1;
	fly_speed=0.01;
	bomb_speed=0.01;
	bomb_destruction=1;
	bomb_speeder=0;
	phase=1;
	level=1;
	up=0;
	stop=0;
	slow=0;
	stop_max_activity_time=1;
	slow_max_activity_time=2;
	up_max_activity_time=1;
	stop_activity_time=0;
	slow_activity_time=0;
	up_activity_time=0;
	slow_active=false;
	stop_active=false;
	up_active=false;
}
void Player::onstart()
{
	x=-3;
	y=0;
}
bool Player::save(char *filename)
{
	FILE *fil;
	if(fil=fopen(filename,"wb"))
	{
		fwrite(&level,sizeof(int),1,fil);
		fwrite(&phase,sizeof(int),1,fil);
		fwrite(&points,sizeof(int),1,fil);
		fwrite(&type_bomber,sizeof(int),1,fil);
		fwrite(&count_bombs,sizeof(int),1,fil);
		fwrite(&fly_speed,sizeof(float),1,fil);
		fwrite(&bomb_speed,sizeof(float),1,fil);
		fwrite(&bomb_destruction,sizeof(int),1,fil);
		fwrite(&bomb_speeder,sizeof(int),1,fil);
		fwrite(&stop,sizeof(int),1,fil);
		fwrite(&slow,sizeof(int),1,fil);
		fwrite(&up,sizeof(int),1,fil);
		fclose(fil);
		return true;
	}
	return false;
}
bool Player::load(char *filename)
{
	FILE *fil;
	if(fil=fopen(filename,"rb"))
	{
		fread(&level,sizeof(int),1,fil);
		fread(&phase,sizeof(int),1,fil);
		fread(&points,sizeof(int),1,fil);
		fread(&type_bomber,sizeof(int),1,fil);
		fread(&count_bombs,sizeof(int),1,fil);
		fread(&fly_speed,sizeof(float),1,fil);
		fread(&bomb_speed,sizeof(float),1,fil);
		fread(&bomb_destruction,sizeof(int),1,fil);
		fread(&bomb_speeder,sizeof(int),1,fil);
		fread(&stop,sizeof(int),1,fil);
		fread(&slow,sizeof(int),1,fil);
		fread(&up,sizeof(int),1,fil);
		fclose(fil);
		return true;
	}
	else
	{
		level=0;
		points=0;
		type_bomber=1;
		count_bombs=1;
		fly_speed=0.05;
		bomb_speed=0.05;
		bomb_destruction=1;
		return false;
	}
}
Player::Player()
{
	x=-3;
	y=0;
	type_bomber=1;
	count_bombs=1;
	fly_speed=0.01;
	y_fly_speed=1;
	bomb_speed=0.01;
	bomb_destruction=1;
	level=0;
	points=0;
	bomb_destruction=1;
	bomb_speeder=0;
	up=0;
	stop=0;
	slow=0;
	stop_max_activity_time=1;
	slow_max_activity_time=2;
	up_max_activity_time=1;
	stop_activity_time=0;
	slow_activity_time=0;
	up_activity_time=0;
	slow_active=false;
	stop_active=false;
	up_active=false;
	frames =new models();
	frames->First=100;
	count_frames=0;
	cur_frame=0;
	anim_speed=0.5;
}


//----------------
class bomb
{
public:
	float x,y;
	bool visible;
	bomb(){x=y=0;visible=false;}
};
//----------------
class game
{
public:
	sprite_effect *image1;
	sprite_effect *image2;

	efExplosion *explosions[10];
	sound *explosions_sound[10];
	int zone_number;
	int count_bricks;;
	int width,height,unival;
	int map[100][100];
	bool ground[100];
	int maxlev;
	int levelpoints;
	int road[200];
	int countcont;
	int cont[100][100][2];
	float building_density;
	float building_detalisation;

	//---------
	int count_types_small;
	int count_types_big;
	//---------
	bomb *bombs[10];
	Player *player;
	game();
	~game();
	game::game(	int zone_num);
	bool gameover();
	bool win();
	void move_player();
	void generate(int Width,int Height, int Max_lev);
	void bombing();
	void drop_bomb();
	void clear();
	void load(int zone_num);
	void unload();
	bool load_conf(char *filename);
	bool save_conf(char *filename);
};
bool game::load_conf(char *filename)
{
	FILE *fil;
	float a,b;
	char buf[200];
	if(fil=fopen(filename,"rb"))
	{
		fscanf(fil,"%s",buf);
		building_density=atof(buf);
		fscanf(fil,"%s",buf);
		building_detalisation=atof(buf);
	}
	else
	{
		 building_density=90;
	     building_detalisation=90;
		 fil=fopen(filename,"wb");
		 fprintf(fil,"%lf %lf",building_density, building_detalisation);
	}
	fclose(fil);
	return true;
}
bool game::save_conf(char *filename)
{
	FILE *fil;
	fil=fopen(filename,"wb");
	fprintf(fil,"%lf %lf",building_density, building_detalisation);
	fclose(fil);
	return true;
}
game::~game()
{
	int a;
		for(a=0;a<10;a++)
		{
			if(explosions[a]!=NULL)
			{	
				delete(explosions[a]);
				explosions[a]=NULL;

				delete(explosions_sound[a]);
				explosions_sound[a]=NULL;
			}
		}

		for(a=0;a<10;a++)
		{
			delete(bombs[a]);
		}
		delete (image1);
		delete (image2);
		delete (player);
}
bool game::win()
{
	int a,b,count;
	for(a=0;a<=width;a++)
	{
		for(b=0;b<=height;b++)
		{
			if(map[a][b]!=0)return false;
		}
	}
	player->phase++;
	if(player->phase>5)
	{
		player->phase=0;
		player->level++;
	}
	player->points+=levelpoints;
	return true;
}
void game::bombing()
{
	int a,b;
	for(a=0;a<10;a++)
	{
		if(bombs[a]->visible==true)
		{
			bombs[a]->y+=(player->bomb_speed+((float)player->bomb_speeder/100));
			if(map[(int)bombs[a]->x][(int)bombs[a]->y]>0)
			{
				player->points++;
				bombs[a]->visible=false;
				for(b=(int)bombs[a]->y;b<(int)bombs[a]->y+player->bomb_destruction;b++)
				{
					map[(int)bombs[a]->x][b]=0;
					explosions[a]->X=(int)bombs[a]->x;
					explosions[a]->Y=(height/2)-(int)bombs[a]->y;
					explosions[a]->Z=0;
				}
				if(map[(int)bombs[a]->x][b]>0)
				{
					map[(int)bombs[a]->x][b]=((map[(int)bombs[a]->x][(int)bombs[a]->y+1]/3)+1)*3;
					explosions[a]->X=(int)bombs[a]->x;
					explosions[a]->Y=(height/2)-(int)bombs[a]->y;
					explosions[a]->Z=0;
					
				}
				//explosions_sound[a]->set_listener_pos(((int)bombs[a]->x-height/2),((height/2)-(int)bombs[a]->y)/height,0);
				explosions_sound[a]->move(width/2-(int)bombs[a]->x,(height/2)-(int)bombs[a]->y,0,0);
				explosions_sound[a]->play(1);
				explosions_sound[a]->play(0);
				explosions[a]->run();
			}
			else if(bombs[a]->y>height)
			{
				bombs[a]->visible=false;
				explosions[a]->X=(int)bombs[a]->x;
				explosions[a]->Y=(height/2)-(int)bombs[a]->y;
				explosions[a]->Z=0;
				explosions[a]->run();
				//explosions_sound[a]->set_listener_pos((int)bombs[a]->x/height,((height/2)-(int)bombs[a]->y)/height,0);
				explosions_sound[a]->move((int)bombs[a]->x,(height/2)-(int)bombs[a]->y,0,0);
				explosions_sound[a]->play(0);
			}
		}
	}
	
}
void game::drop_bomb()
{
	int a,b,count_bombs;
	double ret;
	count_bombs=0;
	for(a=0;a<10;a++)
	{	
		if(bombs[a]->visible==true) count_bombs++;
	}
	if(count_bombs<player->count_bombs)
	{
		if(player->x>=0)
		{
			for(a=0;a<10;a++)
			{
				if(bombs[a]->visible==false)
				{
					modf(player->x,&ret);
					bombs[a]->visible=true;
					bombs[a]->x= (int)ret+player->fly_speed*2;
					bombs[a]->y=player->y;
					break;
				}
			}
		}
	}


}
void game::move_player()
{
	if(player->stop_active==true)
	{
		player->stop_activity_time+=0.01;
		if(player->stop_activity_time>=player->stop_max_activity_time)
		{
			player->stop_activity_time=0;
			player->stop_active=false;
		}
	}
	else if(player->slow_active==true)
	{
		player->slow_activity_time+=0.01;
		player->x+=(player->fly_speed/2);
		if(player->slow_activity_time>=player->slow_max_activity_time)
		{
			player->slow_activity_time=0;
			player->slow_active=false;
		}
	}
	else if(player->up_active==true)
	{
		player->x+=player->fly_speed;
		player->up_activity_time+=0.01;
		player->y-=0.01;
		if(player->up_activity_time>=player->up_max_activity_time)
		{
			player->y=(int)player->y;
			player->up_active=false;
			player->up_activity_time=0;
		}

	}
	else player->x+=player->fly_speed;
	if(player->x>width+3)
	{
		player->x=-3;
		player->y+=player->y_fly_speed;

	}
}

bool game::gameover()
{
	if((int)player->x>=0)
	{
		if(map[(int)player->x][(int)player->y]!=0)
		{
			return true;
		}
		else return false;
	}
	else if ((int)player->y>=height) return true;
	else return false;
}


void game::clear()
{
	//player->clear();
	player->onstart();
	int a,b;

	for(a=0;a<100;a++)
	{
		for(b=0;b<100;b++)
		{
			map[a][b]=0;
		}
	}
	for(a=0;a<10;a++)
	{
		bombs[a]->visible=false;
		explosions[a]->enable=false;

	}
	width=10;
	height=10;
	maxlev=5;
	count_bricks=0;
	count_types_small=1;
	count_types_big=1;
	levelpoints=0;
}
void game::load(int zone_num)
{
	int a,b;
	FILE *fil;
	char buf[800];
	char buf2[100];
sprintf(buf,"");
sprintf(buf2,"sound\\zone%d\\explosion.wav",zone_num);
for(a=0;a<10;a++)
{
	explosions_sound[a]=new sound();
	explosions_sound[a]->open(buf2,0);
}
sprintf(buf,"models\\zone%d\\cont_conf",zone_num);
fil=fopen(buf,"rb");
fscanf(fil,"%d",&countcont);
fclose(fil);
sprintf(buf,"zone%d",zone_num);
player->unload_models();
player->frames->First=300;
player->load_models(buf);
}
void game::unload()
{
	countcont=0;
	int a;
	for(a=0;a<10;a++)
	{
		delete(explosions_sound[a]);
	}
	player->unload_models();
}
game::game()
{
	int a,b;
	
		 building_density=100;
	     building_detalisation=100;
	levelpoints=0;
	zone_number=1;
	image1=new sprite_effect();
	image2=new sprite_effect();
	for(a=0;a<10;a++)
	{
		explosions[a] = new efExplosion;
	}
	count_bricks=0;
	count_types_small=1;
	count_types_big=1;
	player=new Player;
	player->level=1;
	player->phase=1;
	player->count_bombs=1;
	width=10;
	height=10;
	maxlev=5;
	char buf[800];
	
	for(a=0;a<100;a++)
	{
		for(b=0;b<100;b++)
		{
			map[a][b]=0;
		}
	}
	for(a=0;a<10;a++)
	{
		bombs[a]=new bomb();
	}

sprintf(buf,"");
for(a=0;a<=17;a++)
{
	sprintf(buf,"%smaps\\explosive\\explosive00%d.tga ",buf,a);
	
}
image1->load_images(buf);
for(a=0;a<10;a++)
{
	explosions[a]->explosion->image=image1;
	explosions[a]->particles->image=image1;
}
sprintf(buf,"");
for(a=0;a<=17;a++)
{
	sprintf(buf,"%smaps\\smoke\\smoke00%d.tga ",buf,a);
	
}
image2->load_images(buf);

for(a=0;a<10;a++)
{
	explosions[a]->smoke->image=image2;
	explosions[a]->ExplosionHeight=2;
	explosions[a]->ExplosionWidth=2;
	explosions[a]->ParticleWidth=0.5;
	explosions[a]->ParticleHeight=0.5;
	explosions[a]->particles->GForce=0.0001;
	explosions[a]->count_particles_per_time=15;
	explosions[a]->explosion->speed_draw=0.2;
	explosions[a]->pregenerate(10);
	explosions[a]->enable=false;
}



}
game::game(int zone_num)
{
	 building_density=100;
	     building_detalisation=100;
	int a,b;
	levelpoints=0;

	FILE *fil;
	zone_number=zone_num;
	image1=new sprite_effect();
	image2=new sprite_effect();
	for(a=0;a<10;a++)
	{
		explosions[a] = new efExplosion;
		explosions[a]->enable=false;
	}
	count_bricks=0;
	count_types_small=1;
	count_types_big=1;
	player=new Player;
	player->phase=1;
	player->level=1;
	player->count_bombs=1;
	width=10;
	height=10;
	maxlev=5;
	char buf[800];
	char buf2[100];
	
	for(a=0;a<100;a++)
	{
		for(b=0;b<100;b++)
		{
			map[a][b]=0;
		}
	}
	for(a=0;a<10;a++)
	{
		bombs[a]=new bomb();
	}

sprintf(buf,"");
for(a=0;a<=17;a++)
{
	sprintf(buf,"%smaps\\explosive\\explosive00%d.tga ",buf,a);
	
}
image1->load_images(buf);
for(a=0;a<10;a++)
{
	explosions[a]->explosion->image=image1;
	explosions[a]->particles->image=image1;
}
sprintf(buf,"");
for(a=0;a<=17;a++)
{
	sprintf(buf,"%smaps\\smoke\\smoke00%d.tga ",buf,a);
	
}
image2->load_images(buf);
sprintf(buf2,"sound\\zone%d\\explosion.wav",zone_num);
for(a=0;a<10;a++)
{
	explosions_sound[a]=new sound();
	explosions[a]->smoke->image=image2;
	explosions[a]->ExplosionHeight=2;
	explosions[a]->ExplosionWidth=2;
	explosions[a]->ParticleWidth=0.5;
	explosions[a]->ParticleHeight=0.5;
	explosions[a]->particles->GForce=0.0001;
	explosions[a]->count_particles_per_time=20;
	explosions[a]->explosion->speed_draw=0.2;
	explosions[a]->pregenerate(10);
	explosions[a]->enable=false;
	explosions_sound[a]->open(buf2,0);
	
}
sprintf(buf,"models\\zone%d\\cont_conf",zone_num);
fil=fopen(buf,"rb");
fscanf(fil,"%d",&countcont);
fclose(fil);

}
 void game::generate(int Width,int Height, int Max_lev)
{
	width=Width;
	height=Height;
	if(height%2==0)height++;
	maxlev=Max_lev;
	bool use;
	levelpoints=0;
	//----------------------------------
	int a,b,c,e,type;
	float d;
	 srand( (unsigned)time( NULL ) );
	if(Width>=Height)unival=Width;
	else unival=Height;
	for(a=0;a<200;a++)
	{
		road[a]=(rand()%3)+1;
	}
	for(a=0;a<100;a++)
	{
		for(b=0;b<100;b++)
		{
			map[a][b]=0;
		}
	}
	for(a=2;a<=width-2;a++)
	{
		e=rand()%5;
		if(e==1)b=rand()%maxlev;
		else
		{
			b=rand()%maxlev/2;
			b+=maxlev/2;
		}
		levelpoints+=b;
		if(b<=0)b=1;
		if(b>0)
		{
			if(b==1&&count_types_small>0)
			{
				use=1;
				type=rand()%count_types_small;
			}
			else
			{
				use=0;
				type=rand()%count_types_big;
			}
			if(type==0)type=1;
			if(use==0)
			{
				for(c=height;c>height-b;c--)
				{
					count_bricks++;
					map[a][c]=type;	
					if(c==height-b+1)map[a][c]=type+1;
				}
			}
			if(use==1)
			{
				count_bricks++;
				map[a][height]=type+count_types_big*3;
			}
		}
	}
	for(a=0;a<100;a++)
	{
		for(b=0;b<100;b++)
		{
			e=rand()%100+1;
			if(e<building_density)
			{
				cont[a][b][0]=rand()%(countcont+1);
				if (cont[a][b][0]==0)cont[a][b][0]++;
				cont[a][b][1]=(rand()%4)*90;
			}
			else cont[a][b][0]=0;
		}
	}
	for(a=0;a<100;a++)
	{
		cont[50][a][0]=0;
		cont[51][a][0]=0;
		cont[49][a][0]=0;
	}


	
}