#ifndef __menu__
#define __menu__

#include <math.h>
#include "helpers.h"

void calc_selected_line(int mx,int my,CVector3 &p1,CVector3 &p2,float screenheight)
{
	GLint viewport[4];// viewport'a
	GLdouble projection[16];// 
	GLdouble modelview[16];// 
	GLdouble vx,vy,vz; //     viewport'a
	GLdouble wx,wy,wz; //  
	glGetIntegerv(GL_VIEWPORT,viewport);
	glGetDoublev(GL_PROJECTION_MATRIX,projection);
	glGetDoublev(GL_MODELVIEW_MATRIX,modelview);
	vx=mx;
	vy=screenheight-my-1;
	vz=-1;
	gluUnProject(vx,vy,vz,modelview,projection,viewport,&wx,&wy,&wz);
	p1=CVector3(wx,wy,wz);
	vz=1;
	gluUnProject(vx,vy,vz,modelview,projection,viewport,&wx,&wy,&wz);
	p2=CVector3(wx,wy,wz);
}
CVector3* get_point_by_z(CVector3 p1,CVector3 p2, float Z)
{
	float x1,y1,z1;
	float x2,y2,z2;
	double a,b,gip,anga,angb;
	CVector3 *poin=new CVector3();
	poin->z=Z;
	x1=p1.x;
	x2=p2.x;
	y1=p1.y;
	y2=p2.y;
	z1=p1.z;
	z2=p2.z;

	a=x1-x2;
	b=z1-z2;
	anga=atan(a/b);
	gip=Z/cos(anga);
	poin->x=sin(anga)*gip;
	a=y1-y2;
	anga=atan(a/b);
	gip=Z/cos(anga);
	poin->y=sin(anga)*gip;
	return poin;
}
//$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
//        MESSAGE
class message
{
public:
	char text[1024][1024];
	int lines;
	float strspace;
	float x,y,z;
	float width,height;
	textures *Texture;
	bool visible;
	message();
	~message();
	void draw();
	bool set_text(char *str);
	Font *font;
	void load_texture(char *texture);
	bool easy_click(float X,float Y);
};
bool message::set_text(char *str)
{
	int a=0,b=0;
	lines=0;
	while(str[a]!='\0')
	{
		if(str[a]!='\n'&& str[a]!='*')
		{
			text[lines][b]=str[a];
			b++;
		}
		else
		{
			text[lines][b]='\0';
			b=0;
			lines++;
		}
		a++;
	}
	text[lines][b]='\0';
	lines++;
	return 1;
}
message::message()
{
	Texture=new textures();
	lines=0;
	x=y=z=0;
	width=height=1;
	font=new Font();
	visible=false;
	strspace=0.2;
}
message::~message()
{
	delete(Texture);
	delete(font);
}
void message::draw()
{
	int a;
	glBindTexture(GL_TEXTURE_2D,Texture->texture[0]);
	glBegin(GL_POLYGON);
		glTexCoord2f(0.0f,0.0f);glVertex3f(x,y+height,z);
		glTexCoord2f(1.0f,0.0f);glVertex3f(x+width,y+height,z);
		glTexCoord2f(1.0f,1.0f);glVertex3f(x+width,y,z);
		glTexCoord2f(0.0f,1.0f);glVertex3f(x,y,z);
	glEnd();
	for(a=0;a<lines;a++)
	{
		font->glPrint(text[a],x+width/10,(y+height-strspace)-a*strspace,z+0.1);
	}
	
}
void message::load_texture(char *texture)
{
	Texture->buildtexture(texture);
}
bool message::easy_click(float X,float Y)
{	
	if(X>=x && X<=x+width && Y<=y+height && Y>=y) 
	{
		return true;
	}
	return false;
}
//*******************************************************************
//*******************************************************************
//** #####  #     #   #######   #######     ####   #     #         **
//** #    # #     #      #         #       #    #  #     #         **
//** #   #  #     #      #         #       #    #  ##    #         **
//** ####   #     #      #         #       #    #  # #   #         **
//** #   #  #     #      #         #       #    #  #  #  #         **
//** #    #  #   #       #         #       #    #  #   # #         **
//** #####    ###        #         #        ####   #    ##         **
//*******************************************************************
//*******************************************************************

class button
{
	public:
	GLfloat posX;
	GLfloat posY;
	GLfloat posZ;
	//---------------
	GLfloat Width;	// 
	GLfloat Height;	// Y
	GLfloat Length;	// Z
	float strspace;
	textures *Texture;
	int lines;
	bool clicked;
	int screenheight;
	float textposX,textposY;
	Font *Text;
	char caption[1024][1024];
	button(float X,float Y,float Z,float W,float H,float L,char *text,char *texture);
	button(char *text,char *texture);
	button();
	button(float X,float Y,float Z,float W,float H,float L);
	void load_texture(char *texture);
	void move(float X,float Y,float Z);
	void resize(float W,float H,float L);
	void draw();
	bool click(float X,float Y);
	bool easy_click(float X,float Y);
	char name[32];
	void set_text(char* str);
	~button();
};
void button::set_text(char * str)
{

	int a=0,b=0;
	lines=0;
	while(str[a]!='\0')
	{
		if(str[a]!='\n'&& str[a]!='*')
		{
			caption[lines][b]=str[a];
			b++;
		}
		else
		{
			caption[lines][b]='\0';
			b=0;
			lines++;
		}
		a++;
	}
	caption[lines][b]='\0';
	lines++;

}
button::~button()
{
	Text->KillFont();
	delete(Text);
	delete(Texture);
}
button::button(float X,float Y,float Z,float W,float H,float L,char *text,char *texture)
{
	strspace=0.2;
	posX=X;
	posY=Y;
	posZ=Z;
	Width=W;
	Height=H;
	Length=L;
	set_text(text);

	Texture=new textures();
	Texture->buildtexture(texture);
	Text=new Font();
	screenheight=600;
	clicked=false;
}

button::button(char *text,char *texture)
{
	strspace=0.2;
	posX=0;
	posY=0;
	posZ=0;
	Width=1;
	Height=1;
	Length=0;
	set_text(text);

	Texture=new textures();
	Texture->buildtexture(texture);
	Text=new Font();
	screenheight=600;
	clicked=false;
}
button::button()
{
	strspace=0.2;
	posX=posY=posZ=0;
	Width=Height=1;
	Length=0;
	set_text("");
	Texture=new textures();
	Text=new Font();
	screenheight=768;
	clicked=false;
}
button::button(float X,float Y,float Z,float W,float H,float L)
{
	posX=X;
	posY=Y;
	posZ=Z;
	Width=W;
	Height=H;
	Length=L;
	set_text("");
	Texture=new textures();
	Text=new Font();
	screenheight=768;
	clicked=false;
	
}
void button::load_texture(char *texture)
{
	Texture->buildtexture(texture);
}
void button::move(float X,float Y,float Z)
{
	posX=X;
	posY=Y;
	posZ=Z;
}
void button::resize(float W,float H,float L)
{
	Width=W;
	Height=H;
	Length=L;
}
void button::draw()
{
	
	glColor3f(1.0f,1.0f,1.0f);
	glBindTexture(GL_TEXTURE_2D,(unsigned int)Texture->texture[0]);
	int a;
	if(clicked==false)
	{
	glColor3f(1.0f,1.0f,1.0f);
	glBegin(GL_QUADS);
		glNormal3f(0.0f,0.0f,1.0f);
		glTexCoord2f(0.0f,0.0f);glVertex3f(posX,posY,posZ);  //
		glTexCoord2f(1.0f,0.0f);glVertex3f(posX+Width,posY,posZ);
		glTexCoord2f(1.0f,1.0f);glVertex3f(posX+Width,posY-Height,posZ);
		glTexCoord2f(0.0f,1.0f);glVertex3f(posX,posY-Height,posZ);

		glNormal3f(0.0f,1.0f,0.0f);
		glTexCoord2f(0.0f,0.0f);glVertex3f(posX,posY,posZ); //
		glTexCoord2f(1.0f,0.0f);glVertex3f(posX+Width,posY,posZ);
		glTexCoord2f(1.0f,1.0f);glVertex3f(posX+Width,posY,posZ-Length);
		glTexCoord2f(0.0f,1.0f);glVertex3f(posX,posY,posZ-Length);

		glNormal3f(0.0f,-1.0f,0.0f);
		glTexCoord2f(0.0f,0.0f);glVertex3f(posX,posY-Height,posZ); //
		glTexCoord2f(1.0f,0.0f);glVertex3f(posX+Width,posY-Height,posZ);
		glTexCoord2f(1.0f,1.0f);glVertex3f(posX+Width,posY-Height,posZ-Length);
		glTexCoord2f(0.0f,1.0f);glVertex3f(posX,posY-Height,posZ-Length);

		glNormal3f(1.0f,0.0f,0.0f);
		glTexCoord2f(0.0f,0.0f);glVertex3f(posX+Width,posY,posZ);//
		glTexCoord2f(1.0f,0.0f);glVertex3f(posX+Width,posY-Height,posZ);
		glTexCoord2f(1.0f,1.0f);glVertex3f(posX+Width,posY-Height,posZ-Length);
		glTexCoord2f(0.0f,1.0f);glVertex3f(posX+Width,posY,posZ-Length);

		glNormal3f(-1.0f,0.0f,0.0f);
		glTexCoord2f(0.0f,0.0f);glVertex3f(posX,posY,posZ);//
		glTexCoord2f(1.0f,0.0f);glVertex3f(posX,posY-Height,posZ);
		glTexCoord2f(1.0f,1.0f);glVertex3f(posX,posY-Height,posZ-Length);
		glTexCoord2f(0.0f,1.0f);glVertex3f(posX,posY,posZ-Length);
	glEnd();
	glColor3f(0.0f,0.0f,0.0f);
	
	
		for(a=0;a<lines;a++)
		{
			Text->glPrint(caption[a],posX+Width/10,(posY-Height/10-strspace)-a*strspace,posZ+0.1);
		}
	}
	else
	{
	glBegin(GL_QUADS);
		glNormal3f(0.0f,0.0f,1.0f);
		glTexCoord2f(0.0f,0.0f);glVertex3f(posX,posY,posZ-Length/2);  //
		glTexCoord2f(1.0f,0.0f);glVertex3f(posX+Width,posY,posZ-Length/2);
		glTexCoord2f(1.0f,1.0f);glVertex3f(posX+Width,posY-Height,posZ-Length/2);
		glTexCoord2f(0.0f,1.0f);glVertex3f(posX,posY-Height,posZ-Length/2);

		glNormal3f(0.0f,1.0f,0.0f);
		glTexCoord2f(0.0f,0.0f);glVertex3f(posX,posY,posZ-Length/2); //
		glTexCoord2f(1.0f,0.0f);glVertex3f(posX+Width,posY,posZ-Length/2);
		glTexCoord2f(1.0f,1.0f);glVertex3f(posX+Width,posY,posZ-Length);
		glTexCoord2f(0.0f,1.0f);glVertex3f(posX,posY,posZ-Length);

		glNormal3f(0.0f,-1.0f,0.0f);
		glTexCoord2f(0.0f,0.0f);glVertex3f(posX,posY-Height,posZ-Length/2); //
		glTexCoord2f(1.0f,0.0f);glVertex3f(posX+Width,posY-Height,posZ-Length/2);
		glTexCoord2f(1.0f,1.0f);glVertex3f(posX+Width,posY-Height,posZ-Length);
		glTexCoord2f(0.0f,1.0f);glVertex3f(posX,posY-Height,posZ-Length);

		glNormal3f(1.0f,0.0f,0.0f);
		glTexCoord2f(0.0f,0.0f);glVertex3f(posX+Width,posY,posZ-Length/2);//
		glTexCoord2f(1.0f,0.0f);glVertex3f(posX+Width,posY-Height,posZ-Length/2);
		glTexCoord2f(1.0f,1.0f);glVertex3f(posX+Width,posY-Height,posZ-Length);
		glTexCoord2f(0.0f,1.0f);glVertex3f(posX+Width,posY,posZ-Length);

		glNormal3f(-1.0f,0.0f,0.0f);
		glTexCoord2f(0.0f,0.0f);glVertex3f(posX,posY,posZ-Length/2);//
		glTexCoord2f(1.0f,0.0f);glVertex3f(posX,posY-Height,posZ-Length/2);
		glTexCoord2f(1.0f,1.0f);glVertex3f(posX,posY-Height,posZ-Length);
		glTexCoord2f(0.0f,1.0f);glVertex3f(posX,posY,posZ-Length);
	glEnd();
	glColor3f(0.0f,0.0f,0.0f);
	for(a=0;a<lines;a++)
		{
			Text->glPrint(caption[a],posX+Width/10,(posY-Height/10-strspace)-a*strspace,posZ+0.1-Length/2);
		}

	}

}

bool button::click(float X,float Y)
{
	CVector3 vec1;
	CVector3 vec2;
	CVector3 *point;
	calc_selected_line(X,Y,vec1,vec2,screenheight);
	point=get_point_by_z(vec1,vec2,posZ);
	if(point->x>=posX && point->x<=posX+Width && point->y<=posY && point->y>=posY-Height) 
	{
		free(point);
		return true;
	}
	free(point);
	return false;
}
bool button::easy_click(float X,float Y)
{
	if(X>=posX && X<=posX+Width && Y<=posY && Y>=posY-Height) 
	{
		return true;
	}
	return false;
}
//************************************************************
//************************************************************

class slider
{
public:
	float posX,posY,posZ;
	bool Vertical;
	bool clicked;
	float Width,Height,Length;
	float Min,Max,Pos,step;
	int screenheight;
	textures *osnov;
	textures *begunok;
	slider();
	slider(float X,float Y,float Z);
	slider(float X,float Y,float Z,float width,float height,float length);
	float click(int X,int Y);
	float easy_click(float X,float Y);
	void draw();
	float get_value(bool smooth);
	char name[32];
	~slider();
};
slider::~slider()
{


		delete(osnov);
		delete(begunok);
}
slider::slider()
{
	posX=posY=posZ=0;
	Width=Height=Length=1;
	clicked=false;
	Vertical=false;
	Min=0;
	Max=100;
	Pos=50;
	step=1;
	osnov=new textures();
	begunok= new textures();


}
slider::slider(float X,float Y,float Z)
{
	posX=X;
	posY=Y;
	posZ=Z;
	Width=Height=Length=1;
	clicked=false;
	Vertical=false;
	Min=0;
	Max=100;
	Pos=50;
	step=1;
	osnov=new textures();
	begunok= new textures();

}
slider::slider(float X,float Y,float Z,float width,float height,float length)
{
	posX=X;
	posY=Y;
	posZ=Z;
	Width=width;
	Height=height;
	Length=1;
	clicked=false;
	Vertical=false;
	Min=0;
	Max=100;
	Pos=50;
	step=1;
	osnov=new textures();
	begunok= new textures();

}
float slider::click(int X,int Y)
{
	CVector3 vec1;
	CVector3 vec2;
	CVector3 *point;
	calc_selected_line(X,Y,vec1,vec2,screenheight);
	point=get_point_by_z(vec1,vec2,posZ);
	if(point->x>=posX && point->x<=posX+Width && point->y<=posY && point->y>=posY-Height) 
	{
		
		if(Vertical==true)
		{
			float pos,otn;
			Pos=posY-point->y;
			otn=Height/Pos;
			Pos=-Max/otn;
		}
		else
		{
			float pos,otn;
			Pos=posX-point->x;
			otn=Width/Pos;
			Pos=Max/otn;
		}
		free(point);
		return Pos;
	}
	free(point);
	return -1;
}
float slider::easy_click(float X,float Y)
{

	if(X>=posX && X<=posX+Width && Y<=posY && Y>=posY-Height) 
	{
		
		if(Vertical==true)
		{
			float pos,otn;
			Pos=posY-Y;
			otn=Height/Pos;
			Pos=-Max/otn;
		}
		else
		{
			float pos,otn;
			Pos=posX-X;
			otn=Width/Pos;
			Pos=Max/otn;
		}
		return Pos;
	}
	return -1;
}
void slider::draw()
{
	if(Vertical==true)
	{

		glBindTexture(GL_TEXTURE_2D,(unsigned int)osnov->texture[0]);
		glBegin(GL_QUADS);

		glNormal3f(0.0f,0.0f,1.0f);
		glTexCoord2f(0.0f,1.0f);glVertex3f(posX,posY,posZ-Length);
		glTexCoord2f(1.0f,1.0f);glVertex3f(posX+Width/3,posY,posZ);
		glTexCoord2f(1.0f,0.0f);glVertex3f(posX+Width/3,posY-Height,posZ);
		glTexCoord2f(0.0f,0.0f);glVertex3f(posX,posY-Height,posZ-Length);

		glTexCoord2f(0.0f,1.0f);glVertex3f(posX+(Width/3)*2,posY,posZ);
		glTexCoord2f(1.0f,1.0f);glVertex3f(posX+Width,posY,posZ-Length);
		glTexCoord2f(1.0f,0.0f);glVertex3f(posX+Width,posY-Height,posZ-Length);
		glTexCoord2f(0.0f,0.0f);glVertex3f(posX+(Width/3)*2,posY-Height,posZ);

		glNormal3f(1.0f,0.0f,1.0f);
		glTexCoord2f(0.0f,1.0f);glVertex3f(posX+Width/3,posY,posZ);
		glTexCoord2f(1.0f,1.0f);glVertex3f(posX+Width/2,posY,posZ-Length);
		glTexCoord2f(1.0f,0.0f);glVertex3f(posX+Width/2,posY-Height,posZ-Length);
		glTexCoord2f(0.0f,0.0f);glVertex3f(posX+Width/3,posY-Height,posZ);
		
		glNormal3f(-1.0f,0.0f,1.0f);
		glTexCoord2f(0.0f,1.0f);glVertex3f(posX+Width/2,posY,posZ-Length);
		glTexCoord2f(1.0f,1.0f);glVertex3f(posX+(Width/3)*2,posY,posZ);
		glTexCoord2f(1.0f,0.0f);glVertex3f(posX+(Width/3)*2,posY-Height,posZ);
		glTexCoord2f(0.0f,0.0f);glVertex3f(posX+Width/2,posY-Height,posZ-Length);
		


		glNormal3f(0.0f,-1.0f,1.0f);
		glTexCoord2f(0.0f,1.0f);glVertex3f(posX,posY-Height,posZ-Length);
		glTexCoord2f(1.0f,1.0f);glVertex3f(posX+Width/3,posY-Height,posZ);
		glTexCoord2f(1.0f,0.0f);glVertex3f(posX+(Width/3)*2,posY-Height,posZ);
		glTexCoord2f(0.0f,0.0f);glVertex3f(posX+Width,posY-Height,posZ-Length);
		
		glNormal3f(0.0f,1.0f,1.0f);
		glTexCoord2f(0.0f,1.0f);glVertex3f(posX,posY,posZ-Length);
		glTexCoord2f(1.0f,1.0f);glVertex3f(posX+Width/3,posY,posZ);
		glTexCoord2f(1.0f,0.0f);glVertex3f(posX+(Width/3)*2,posY,posZ);
		glTexCoord2f(0.0f,0.0f);glVertex3f(posX+Width,posY,posZ-Length);

		glEnd();
		glBegin(GL_TRIANGLES);
		glNormal3f(0.0f,1.0f,0.0f);
		glTexCoord2f(0.0f,1.0f);glVertex3f(posX+Width/3,posY,posZ);
		glTexCoord2f(1.0f,1.0f);glVertex3f(posX+Width/2,posY,posZ-Length);
		glTexCoord2f(1.0f,0.0f);glVertex3f(posX+(Width/3)*2,posY,posZ);
		glEnd();
		glBegin(GL_TRIANGLES);
		glNormal3f(0.0f,-1.0f,0.0f);
		glTexCoord2f(0.0f,1.0f);glVertex3f(posX+Width/3,posY-Height,posZ);
		glTexCoord2f(1.0f,1.0f);glVertex3f(posX+Width/2,posY-Height,posZ-Length);
		glTexCoord2f(1.0f,0.0f);glVertex3f(posX+(Width/3)*2,posY-Height,posZ);
		glEnd();

		//
	
		glBindTexture(GL_TEXTURE_2D,(unsigned int)begunok->texture[0]);
		glBegin(GL_TRIANGLES);
		glNormal3f(-1.0f,1.0f,1.0f);
		glTexCoord2f(1.0f,1.0f);glVertex3f(posX+Width/2,posY+Pos*(Height/(Max-Min))+(Height/20),posZ);
		glTexCoord2f(1.0f,0.0f);glVertex3f(posX+Width/2,posY+Pos*(Height/(Max-Min)),posZ+Length);
		glTexCoord2f(0.0f,0.0f);glVertex3f(posX+Width/3,posY+Pos*(Height/(Max-Min)),posZ);
		
		glNormal3f(-1.0f,-1.0f,1.0f);
		glTexCoord2f(1.0f,1.0f);glVertex3f(posX+Width/2,posY+Pos*(Height/(Max-Min))-(Height/20),posZ);
		glTexCoord2f(1.0f,0.0f);glVertex3f(posX+Width/2,posY+Pos*(Height/(Max-Min)),posZ+Length);
		glTexCoord2f(0.0f,0.0f);glVertex3f(posX+Width/3,posY+Pos*(Height/(Max-Min)),posZ);
		
		glNormal3f(1.0f,1.0f,1.0f);
		glTexCoord2f(1.0f,1.0f);glVertex3f(posX+Width/2,posY+Pos*(Height/(Max-Min))+(Height/20),posZ);
		glTexCoord2f(1.0f,0.0f);glVertex3f(posX+Width/2,posY+Pos*(Height/(Max-Min)),posZ+Length);
		glTexCoord2f(0.0f,0.0f);glVertex3f(posX+(Width/3)*2,posY+Pos*(Height/(Max-Min)),posZ);
		
		glNormal3f(1.0f,-1.0f,1.0f);
		glTexCoord2f(1.0f,1.0f);glVertex3f(posX+Width/2,posY+Pos*(Height/(Max-Min))-(Height/20),posZ);
		glTexCoord2f(1.0f,0.0f);glVertex3f(posX+Width/2,posY+Pos*(Height/(Max-Min)),posZ+Length);
		glTexCoord2f(0.0f,0.0f);glVertex3f(posX+(Width/3)*2,posY+Pos*(Height/(Max-Min)),posZ);



		glNormal3f(-1.0f,1.0f,-1.0f);
		glTexCoord2f(1.0f,1.0f);glVertex3f(posX+Width/2,posY+Pos*(Height/(Max-Min))+(Height/20),posZ);
		glTexCoord2f(1.0f,0.0f);glVertex3f(posX+Width/2,posY+Pos*(Height/(Max-Min)),posZ-Length);
		glTexCoord2f(0.0f,0.0f);glVertex3f(posX+Width/3,posY+Pos*(Height/(Max-Min)),posZ);
		
		glNormal3f(-1.0f,-1.0f,-1.0f);
		glTexCoord2f(1.0f,1.0f);glVertex3f(posX+Width/2,posY+Pos*(Height/(Max-Min))-(Height/20),posZ);
		glTexCoord2f(1.0f,0.0f);glVertex3f(posX+Width/2,posY+Pos*(Height/(Max-Min)),posZ-Length);
		glTexCoord2f(0.0f,0.0f);glVertex3f(posX+Width/3,posY+Pos*(Height/(Max-Min)),posZ);
		
		glNormal3f(1.0f,1.0f,-1.0f);
		glTexCoord2f(1.0f,1.0f);glVertex3f(posX+Width/2,posY+Pos*(Height/(Max-Min))+(Height/20),posZ);
		glTexCoord2f(1.0f,0.0f);glVertex3f(posX+Width/2,posY+Pos*(Height/(Max-Min)),posZ-Length);
		glTexCoord2f(0.0f,0.0f);glVertex3f(posX+(Width/3)*2,posY+Pos*(Height/(Max-Min)),posZ);
		
		glNormal3f(1.0f,-1.0f,-1.0f);
		glTexCoord2f(1.0f,1.0f);glVertex3f(posX+Width/2,posY+Pos*(Height/(Max-Min))-(Height/20),posZ);
		glTexCoord2f(1.0f,0.0f);glVertex3f(posX+Width/2,posY+Pos*(Height/(Max-Min)),posZ-Length);
		glTexCoord2f(0.0f,0.0f);glVertex3f(posX+(Width/3)*2,posY+Pos*(Height/(Max-Min)),posZ);
		glEnd();
	
	}
	if(Vertical==false)
	{

		glBindTexture(GL_TEXTURE_2D,(unsigned int)osnov->texture[0]);
		glBegin(GL_QUADS);

		glNormal3f(0.0f,0.0f,1.0f);
		glTexCoord2f(0.0f,1.0f);glVertex3f(posX,posY,posZ-Length);
		glTexCoord2f(1.0f,1.0f);glVertex3f(posX,posY-Height/3,posZ);
		glTexCoord2f(1.0f,0.0f);glVertex3f(posX+Width,posY-Height/3,posZ);
		glTexCoord2f(0.0f,0.0f);glVertex3f(posX+Width,posY,posZ-Length);

		glTexCoord2f(0.0f,1.0f);glVertex3f(posX,posY-(Height/3)*2,posZ);
		glTexCoord2f(1.0f,1.0f);glVertex3f(posX,posY-Height,posZ-Length);
		glTexCoord2f(1.0f,0.0f);glVertex3f(posX+Width,posY-Height,posZ-Length);
		glTexCoord2f(0.0f,0.0f);glVertex3f(posX+Width,posY-(Height/3)*2,posZ);

		glNormal3f(1.0f,0.0f,1.0f);
		glTexCoord2f(0.0f,1.0f);glVertex3f(posX,posY-Height/3,posZ);
		glTexCoord2f(1.0f,1.0f);glVertex3f(posX,posY-Height/2,posZ-Length);
		glTexCoord2f(1.0f,0.0f);glVertex3f(posX+Width,posY-Height/2,posZ-Length);
		glTexCoord2f(0.0f,0.0f);glVertex3f(posX+Width,posY-Height/3,posZ);
		
		glNormal3f(-1.0f,0.0f,1.0f);
		glTexCoord2f(0.0f,1.0f);glVertex3f(posX,posY-Height/2,posZ-Length);
		glTexCoord2f(1.0f,1.0f);glVertex3f(posX,posY-(Height/3)*2,posZ);
		glTexCoord2f(1.0f,0.0f);glVertex3f(posX+Width,posY-(Height/3)*2,posZ);
		glTexCoord2f(0.0f,0.0f);glVertex3f(posX+Width,posY-Height/2,posZ-Length);
		glEnd();
		glBegin(GL_QUADS);
		glNormal3f(-1.0f,0.0f,0.0f);
		glTexCoord2f(0.0f,1.0f);glVertex3f(posX,posY,posZ-Length);
		glTexCoord2f(1.0f,1.0f);glVertex3f(posX,posY-(Height/3),posZ);
		glTexCoord2f(1.0f,0.0f);glVertex3f(posX,posY-(Height/3)*2,posZ);
		glTexCoord2f(0.0f,0.0f);glVertex3f(posX,posY-Height,posZ-Length);


		glNormal3f(1.0f,0.0f,0.0f);
		glTexCoord2f(0.0f,1.0f);glVertex3f(posX+Width,posY,posZ-Length);
		glTexCoord2f(1.0f,1.0f);glVertex3f(posX+Width,posY-(Height/3),posZ);
		glTexCoord2f(1.0f,0.0f);glVertex3f(posX+Width,posY-(Height/3)*2,posZ);
		glTexCoord2f(0.0f,0.0f);glVertex3f(posX+Width,posY-Height,posZ-Length);
		glEnd();

		glBegin(GL_TRIANGLES);
		glNormal3f(0.0f,1.0f,0.0f);
		glTexCoord2f(0.0f,1.0f);glVertex3f(posX,posY-Height/3,posZ);
		glTexCoord2f(1.0f,1.0f);glVertex3f(posX,posY-Height/2,posZ-Length);
		glTexCoord2f(1.0f,0.0f);glVertex3f(posX,posY-(Height/3)*2,posZ);
		glEnd();
		glBegin(GL_TRIANGLES);
		glNormal3f(0.0f,-1.0f,0.0f);
		glTexCoord2f(0.0f,1.0f);glVertex3f(posX+Width,posY-Height/3,posZ);
		glTexCoord2f(1.0f,1.0f);glVertex3f(posX+Width,posY-Height/2,posZ-Length);
		glTexCoord2f(1.0f,0.0f);glVertex3f(posX+Width,posY-(Height/3)*2,posZ);
		glEnd();

		//
	
		glBindTexture(GL_TEXTURE_2D,(unsigned int)begunok->texture[0]);
		glBegin(GL_TRIANGLES);
		glNormal3f(-1.0f,1.0f,1.0f);
		glTexCoord2f(1.0f,1.0f);glVertex3f(posX-Pos*(Width/(Max-Min))+(Width/20),posY-Height/2,posZ);
		glTexCoord2f(1.0f,0.0f);glVertex3f(posX-Pos*(Width/(Max-Min)),posY-Height/2,posZ+Length);
		glTexCoord2f(0.0f,0.0f);glVertex3f(posX-Pos*(Width/(Max-Min)),posY-Height/3,posZ);
		
		glNormal3f(-1.0f,-1.0f,1.0f);
		glTexCoord2f(1.0f,1.0f);glVertex3f(posX-Pos*(Width/(Max-Min))-(Width/20),posY-Height/2,posZ);
		glTexCoord2f(1.0f,0.0f);glVertex3f(posX-Pos*(Width/(Max-Min)),posY-Height/2,posZ+Length);
		glTexCoord2f(0.0f,0.0f);glVertex3f(posX-Pos*(Width/(Max-Min)),posY-Height/3,posZ);
		
		glNormal3f(-1.0f,1.0f,1.0f);
		glTexCoord2f(1.0f,1.0f);glVertex3f(posX-Pos*(Width/(Max-Min))+(Width/20),posY-Height/2,posZ);
		glTexCoord2f(1.0f,0.0f);glVertex3f(posX-Pos*(Width/(Max-Min)),posY-Height/2,posZ+Length);
		glTexCoord2f(0.0f,0.0f);glVertex3f(posX-Pos*(Width/(Max-Min)),posY-(Height/3)*2,posZ);
		
		glNormal3f(-1.0f,-1.0f,1.0f);
		glTexCoord2f(1.0f,1.0f);glVertex3f(posX-Pos*(Width/(Max-Min))-(Width/20),posY-Height/2,posZ);
		glTexCoord2f(1.0f,0.0f);glVertex3f(posX-Pos*(Width/(Max-Min)),posY-Height/2,posZ+Length);
		glTexCoord2f(0.0f,0.0f);glVertex3f(posX-Pos*(Width/(Max-Min)),posY-(Height/3)*2,posZ);



		glNormal3f(-1.0f,1.0f,-1.0f);
		glTexCoord2f(1.0f,1.0f);glVertex3f(posX-Pos*(Width/(Max-Min))+(Width/20),posY-Height/2,posZ);
		glTexCoord2f(1.0f,0.0f);glVertex3f(posX-Pos*(Width/(Max-Min)),posY-Height/2,posZ-Length);
		glTexCoord2f(0.0f,0.0f);glVertex3f(posX-Pos*(Width/(Max-Min)),posY-Height/3,posZ);
		
		glNormal3f(-1.0f,-1.0f,-1.0f);
		glTexCoord2f(1.0f,1.0f);glVertex3f(posX-Pos*(Width/(Max-Min))-(Width/20),posY-Height/2,posZ);
		glTexCoord2f(1.0f,0.0f);glVertex3f(posX-Pos*(Width/(Max-Min)),posY-Height/2,posZ-Length);
		glTexCoord2f(0.0f,0.0f);glVertex3f(posX-Pos*(Width/(Max-Min)),posY-Height/3,posZ);
		
		glNormal3f(-1.0f,1.0f,-1.0f);
		glTexCoord2f(1.0f,1.0f);glVertex3f(posX-Pos*(Width/(Max-Min))+(Width/20),posY-Height/2,posZ);
		glTexCoord2f(1.0f,0.0f);glVertex3f(posX-Pos*(Width/(Max-Min)),posY-Height/2,posZ-Length);
		glTexCoord2f(0.0f,0.0f);glVertex3f(posX-Pos*(Width/(Max-Min)),posY-(Height/3)*2,posZ);
		
		glNormal3f(-1.0f,-1.0f,-1.0f);
		glTexCoord2f(1.0f,1.0f);glVertex3f(posX-Pos*(Width/(Max-Min))-(Width/20),posY-Height/2,posZ);
		glTexCoord2f(1.0f,0.0f);glVertex3f(posX-Pos*(Width/(Max-Min)),posY-Height/2,posZ-Length);
		glTexCoord2f(0.0f,0.0f);glVertex3f(posX-Pos*(Width/(Max-Min)),posY-(Height/3)*2,posZ);
		glEnd();
	}
}
float slider::get_value(bool smooth)
{
	float pos;
	pos=-Pos;
	if (smooth==true)	pos=ceil(pos);
	return pos;
}
//#################################################FLAT MENU#######################
//#################################################################################
//###############FLAT MENU#########################################################
//####################################FLAT MENU####################################
//#############################################################FLAT MENU###########
//#######FLAT MENU#################################################################

class flat_menu
{
public:
	float posX,posY,posZ,width,height,screen_height;
	textures *texture;
	slider *sliders[32];
	button *buttons[32];
	message *messages[32];
	bool button_clicked[32];
	bool message_clicked[32];
	bool slider_moved[32];
	int count_sliders,count_buttons,count_messages;
	float zerolevel;
	bool load_from_file(char *fliename,HDC hDC);
	flat_menu();
	flat_menu(char *filename,HDC hDC);
	bool click(float X,float Y);
	void draw();
	void unclick();
	void set_screen_height(int screen_height);
	~flat_menu();
};
void flat_menu::set_screen_height(int Screen_height)
{
	int a;
	screen_height=Screen_height;
	for(a=0;a<count_buttons;a++)
	{
		buttons[a]->screenheight=screen_height;
	}
	for(a=0;a<count_sliders;a++)
	{
		sliders[a]->screenheight=screen_height;
	}


}
flat_menu::~flat_menu()
{
	delete(texture);
	int a;
	for(a=0;a<count_sliders;a++)
	{
		delete(sliders[a]);
	}
	for(a=0;a<count_buttons;a++)
	{
		delete(buttons[a]);
	}
}
flat_menu::flat_menu()
{
	screen_height=240;
	count_sliders=0;
	count_buttons=0;
	count_messages=0;
	texture=new textures();
	zerolevel=0;
}
flat_menu::flat_menu(char *filename,HDC hDC)
{
	screen_height=240;
	count_sliders=0;
	count_buttons=0;
	count_messages=0;
	texture=new textures();
	zerolevel=0;
	load_from_file(filename,hDC);
	
}
bool flat_menu::load_from_file(char *filename,HDC hDC)
{
	FILE *fil;
	char buf[1024];
	char *buf2;
	int flag;//0-empty 1-main 2-slider 3-button 4-message
	flag=0;
	if(fil=fopen(filename,"rb"))
	{
		while(!feof(fil))
		{
			fgets(buf,1024,fil);
			ltrim(buf);
			rtrim(buf);
			if(flag==2)
			{
				if(strstr(buf,"width")!=NULL)
				{
					buf2=strstr(buf,"=");
					strmoveleft(buf2,1);
					ltrim(buf2);
					sliders[count_sliders-1]->Width=atof(buf2);

				}
				else if(strstr(buf,"height")!=NULL)
				{
					buf2=strstr(buf,"=");
					strmoveleft(buf2,1);
					ltrim(buf2);
					sliders[count_sliders-1]->Height=atof(buf2);

				}
				else if(strstr(buf,"length")!=NULL)
				{
					buf2=strstr(buf,"=");
					strmoveleft(buf2,1);
					ltrim(buf2);
					sliders[count_sliders-1]->Length=atof(buf2);

				}
				else if(strstr(buf,"posx")!=NULL)
				{
					buf2=strstr(buf,"=");
					strmoveleft(buf2,1);
					ltrim(buf2);
					sliders[count_sliders-1]->posX=atof(buf2);

				}
				else if(strstr(buf,"posy")!=NULL)
				{
					buf2=strstr(buf,"=");
					strmoveleft(buf2,1);
					ltrim(buf2);
					sliders[count_sliders-1]->posY=atof(buf2);

				}
				else if(strstr(buf,"posz")!=NULL)
				{
					buf2=strstr(buf,"=");
					strmoveleft(buf2,1);
					ltrim(buf2);
					sliders[count_sliders-1]->posZ=atof(buf2);

				}
				else if(strstr(buf,"max")!=NULL)
				{
					buf2=strstr(buf,"=");
					strmoveleft(buf2,1);
					ltrim(buf2);
					sliders[count_sliders-1]->Max =atof(buf2);

				}
				else if(strstr(buf,"min")!=NULL)
				{
					buf2=strstr(buf,"=");
					strmoveleft(buf2,1);
					ltrim(buf2);
					sliders[count_sliders-1]->Min=atof(buf2);

				}
				else if(strstr(buf,"pos")!=NULL)
				{
					buf2=strstr(buf,"=");
					strmoveleft(buf2,1);
					ltrim(buf2);
					sliders[count_sliders-1]->Pos=atof(buf2);

				}
				else if(strstr(buf,"vertical")!=NULL)
				{
					buf2=strstr(buf,"=");
					strmoveleft(buf2,1);
					ltrim(buf2);
					if(strstr(buf2,"true")!=NULL) sliders[count_sliders-1]->Vertical=true;
					else sliders[count_sliders-1]->Vertical=false;

				}
				else if(strstr(buf,"body_texture")!=NULL)
				{ 
					buf2=strstr(buf,"=");
					strmoveleft(buf2,1);
					ltrim(buf2);
					sliders[count_sliders-1]->osnov->buildtexture(buf2);

				}
				else if(strstr(buf,"begunok_texture")!=NULL)
				{
					buf2=strstr(buf,"=");
					strmoveleft(buf2,1);
					ltrim(buf2);
					sliders[count_sliders-1]->begunok->buildtexture(buf2);

				}
				else if(strstr(buf,"name")!=NULL)
				{
					buf2=strstr(buf,"=");
					strmoveleft(buf2,1);
					ltrim(buf2);
					sprintf(sliders[count_sliders-1]->name,"%s",buf2);

				}
			}
			//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
			//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
			//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
			//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
			if(flag==3)
			{
				if(strstr(buf,"width")!=NULL)
				{
					buf2=strstr(buf,"=");
					strmoveleft(buf2,1);
					ltrim(buf2);
					buttons[count_buttons-1]->Width=atof(buf2);

				}
				else if(strstr(buf,"height")!=NULL)
				{
					buf2=strstr(buf,"=");
					strmoveleft(buf2,1);
					ltrim(buf2);
					buttons[count_buttons-1]->Height=atof(buf2);

				}
				else if(strstr(buf,"length")!=NULL)
				{
					buf2=strstr(buf,"=");
					strmoveleft(buf2,1);
					ltrim(buf2);
					buttons[count_buttons-1]->Length=atof(buf2);

				}
				else if(strstr(buf,"posx")!=NULL)
				{
					buf2=strstr(buf,"=");
					strmoveleft(buf2,1);
					ltrim(buf2);
					buttons[count_buttons-1]->posX=atof(buf2);

				}
				else if(strstr(buf,"posy")!=NULL)
				{
					buf2=strstr(buf,"=");
					strmoveleft(buf2,1);
					ltrim(buf2);
					buttons[count_buttons-1]->posY=atof(buf2);

				}
				else if(strstr(buf,"posz")!=NULL)
				{
					buf2=strstr(buf,"=");
					strmoveleft(buf2,1);
					ltrim(buf2);
					buttons[count_buttons-1]->posZ=atof(buf2);

				}
				else if(strstr(buf,"Text")!=NULL)
				{
					buf2=strstr(buf,"=");
					strmoveleft(buf2,1);
					ltrim(buf2);
					buttons[count_buttons-1]->set_text(buf2);

				}
				else if(strstr(buf,"texture")!=NULL)
				{ 
					buf2=strstr(buf,"=");
					strmoveleft(buf2,1);
					ltrim(buf2);
					buttons[count_buttons-1]->Texture->buildtexture(buf2);

				}
				else if(strstr(buf,"name")!=NULL)
				{
					buf2=strstr(buf,"=");
					strmoveleft(buf2,1);
					ltrim(buf2);
					sprintf(buttons[count_buttons-1]->name,"%s",buf2);

				}
				else if(strstr(buf,"clicked")!=NULL)
				{
					buf2=strstr(buf,"=");
					strmoveleft(buf2,1);
					ltrim(buf2);
					if(strcmp(buf2,"true")==0)buttons[count_buttons-1]->clicked=true;
					else buttons[count_buttons-1]->clicked=false;

				}
				else if(strstr(buf,"font")!=NULL)
				{
					buf2=strstr(buf,"=");
					strmoveleft(buf2,1);
					ltrim(buf2);
					char font[64];
					char size[10];
					char ang[10];
					sprintf(font,"%s",buf2);
					font[strlen(buf2)-strlen(strstr(buf2,","))]='\0';
					rtrim(font);
					strmoveleft(buf2,strlen(buf2)-strlen(strstr(buf2,","))+1);
					ltrim(buf2);
					sprintf(size,"%s",buf2);
					size[strlen(buf2)-strlen(strstr(buf2,","))]='\0';
					rtrim(size);
					strmoveleft(buf2,strlen(buf2)-strlen(strstr(buf2,","))+1);
					ltrim(buf2);
					sprintf(ang,"%s",buf2);
					ltrim(ang);
					rtrim(ang);
					if(screen_height==240)	buttons[count_buttons-1]->Text->BuildFont(font,atof(size),atof(ang),hDC);
					else if(screen_height==480)	buttons[count_buttons-1]->Text->BuildFont(font,atof(size)+10,atof(ang),hDC);
					else if(screen_height==600)	buttons[count_buttons-1]->Text->BuildFont(font,atof(size)+20,atof(ang),hDC);
					else if(screen_height==768)	buttons[count_buttons-1]->Text->BuildFont(font,atof(size)+25,atof(ang),hDC);
					else if(screen_height==1024)	buttons[count_buttons-1]->Text->BuildFont(font,atof(size)+35,atof(ang),hDC);
					else 	buttons[count_buttons-1]->Text->BuildFont(font,atof(size),atof(ang),hDC);
				}
			}
			if(flag==4)
			{
				if(strstr(buf,"width")!=NULL)
				{
					buf2=strstr(buf,"=");
					strmoveleft(buf2,1);
					ltrim(buf2);
					messages[count_messages-1]->width=atof(buf2);

				}
				else if(strstr(buf,"height")!=NULL)
				{
					buf2=strstr(buf,"=");
					strmoveleft(buf2,1);
					ltrim(buf2);
					messages[count_messages-1]->height=atof(buf2);

				}
				else if(strstr(buf,"posx")!=NULL)
				{
					buf2=strstr(buf,"=");
					strmoveleft(buf2,1);
					ltrim(buf2);
					messages[count_messages-1]->x=atof(buf2);

				}
				else if(strstr(buf,"posy")!=NULL)
				{
					buf2=strstr(buf,"=");
					strmoveleft(buf2,1);
					ltrim(buf2);
					messages[count_messages-1]->y=atof(buf2);

				}
				else if(strstr(buf,"posz")!=NULL)
				{
					buf2=strstr(buf,"=");
					strmoveleft(buf2,1);
					ltrim(buf2);
					messages[count_messages-1]->z=atof(buf2);

				}
				else if(strstr(buf,"Text")!=NULL)
				{
					buf2=strstr(buf,"=");
					strmoveleft(buf2,1);
					ltrim(buf2);
					messages[count_messages-1]->set_text(buf2);

				}
				else if(strstr(buf,"texture")!=NULL)
				{ 
					buf2=strstr(buf,"=");
					strmoveleft(buf2,1);
					ltrim(buf2);
					messages[count_messages-1]->Texture->buildtexture(buf2);

				}
				else if(strstr(buf,"visible")!=NULL)
				{ 
					buf2=strstr(buf,"=");
					strmoveleft(buf2,1);
					ltrim(buf2);
					if(strstr(buf2,"true")||strstr(buf2,"1"))messages[count_messages-1]->visible=true;
					else messages[count_messages-1]->visible=false ;
				}
				else if(strstr(buf,"font")!=NULL)
				{
					buf2=strstr(buf,"=");
					strmoveleft(buf2,1);
					ltrim(buf2);
					char font[64];
					char size[10];
					char ang[10];
					sprintf(font,"%s",buf2);
					font[strlen(buf2)-strlen(strstr(buf2,","))]='\0';
					rtrim(font);
					strmoveleft(buf2,strlen(buf2)-strlen(strstr(buf2,","))+1);
					ltrim(buf2);
					sprintf(size,"%s",buf2);
					size[strlen(buf2)-strlen(strstr(buf2,","))]='\0';
					rtrim(size);
					strmoveleft(buf2,strlen(buf2)-strlen(strstr(buf2,","))+1);
					ltrim(buf2);
					sprintf(ang,"%s",buf2);
					ltrim(ang);
					rtrim(ang);
					if(screen_height==240)	messages[count_messages-1]->font->BuildFont(font,atof(size),atof(ang),hDC);
					else if(screen_height==480)	messages[count_messages-1]->font->BuildFont(font,atof(size)+10,atof(ang),hDC);
					else if(screen_height==600)	messages[count_messages-1]->font->BuildFont(font,atof(size)+20,atof(ang),hDC);
					else if(screen_height==768)	messages[count_messages-1]->font->BuildFont(font,atof(size)+25,atof(ang),hDC);
					else if(screen_height==1024)	messages[count_messages-1]->font->BuildFont(font,atof(size)+35,atof(ang),hDC);
					else 	messages[count_messages-1]->font->BuildFont(font,atof(size),atof(ang),hDC);


				}
			}
			if (flag==1)
			{
				if(strstr(buf,"zerolevel")!=NULL)
				{
					buf2=strstr(buf,"=");
					strmoveleft(buf2,1);
					ltrim(buf2);
					zerolevel=atof(buf2);

				}
				if(strstr(buf,"posy")!=NULL)
				{
					buf2=strstr(buf,"=");
					strmoveleft(buf2,1);
					ltrim(buf2);
					posY=atof(buf2);

				}
				else if(strstr(buf,"posx")!=NULL)
				{
					buf2=strstr(buf,"=");
					strmoveleft(buf2,1);
					ltrim(buf2);
					posX=atof(buf2);
				}
				else if(strstr(buf,"posz")!=NULL)
				{
					buf2=strstr(buf,"=");
					strmoveleft(buf2,1);
					ltrim(buf2);
					posZ=atof(buf2);
				}
				else if(strstr(buf,"width")!=NULL)
				{
					buf2=strstr(buf,"=");
					strmoveleft(buf2,1);
					ltrim(buf2);
					width=atof(buf2);
				}
				else if(strstr(buf,"height")!=NULL)
				{
					buf2=strstr(buf,"=");
					strmoveleft(buf2,1);
					ltrim(buf2);
					height=atof(buf2);
				}
				else if(strstr(buf,"screen_Height")!=NULL)
				{
					buf2=strstr(buf,"=");
					strmoveleft(buf2,1);
					ltrim(buf2);
					screen_height=atof(buf2);
				}
				else if(strstr(buf,"texture")!=NULL)
				{
					buf2=strstr(buf,"=");
					strmoveleft(buf2,1);
					ltrim(buf2);
					texture->buildtexture(buf2);
				}
			}
			//###########################################
			if(strstr(buf,"<slider>")!=NULL)
			{
				sliders[count_sliders]=new slider;
				count_sliders++;
				flag=2;
			}
			if(strstr(buf,"<button>")!=NULL)
			{
				buttons[count_buttons]=new button;
				count_buttons++;
				flag=3;
			}
			if(strstr(buf,"<message>")!=NULL)
			{
				messages[count_messages]=new message;
				count_messages++;
				flag=4;
			}
			else if(strstr(buf,"main")!=NULL)flag=1;
			else if(strstr(buf,"/slider")!=NULL)flag=0;
			else if(strstr(buf,"/button")!=NULL)flag=0;
			else if(strstr(buf,"/main")!=NULL)flag=0;
			else if(strstr(buf,"/message")!=NULL)flag=0;
		}
		for(int a=0;a<count_sliders;a++)
		{
			sliders[a]->screenheight=screen_height;
		}
		for( a=0;a<count_buttons;a++)
		{
			buttons[a]->screenheight=screen_height;
		}
		return true;
	}
	else return false;
}
bool flat_menu::click(float X,float Y)
{
	bool flag;
	int a;
	flag=false;
	CVector3 vec1;
	CVector3 vec2;
	CVector3 *point;
	calc_selected_line(X,Y,vec1,vec2,screen_height);
	point=get_point_by_z(vec1,vec2,zerolevel);
	for( a=0;a<count_messages;a++)
	{
		if(messages[a]->easy_click(point->x,point->y)==true&&messages[a]->visible==true)
		{
			message_clicked[a]=true;
			flag=true;
		}
	}
	if (flag==false)
	{
	for(a=0;a<count_sliders;a++)
	{
		slider_moved[a]=false;
	}
	for( a=0;a<count_buttons;a++)
	{
		buttons[a]->clicked=false;
		button_clicked[a]=false;
	}
	for( a=0;a<count_sliders;a++)
	{
		if(sliders[a]->easy_click(point->x,point->y)==true)
		{
			slider_moved[a]=true;
			flag=true;
		}
	}
	for( a=0;a<count_buttons;a++)
	{
		if(buttons[a]->easy_click(point->x,point->y)==true)
		{
			button_clicked[a]=true;
			buttons[a]->clicked=true;
			flag=true;
		}
	}
	}
	return flag;

}
void flat_menu::draw()
{
	glBindTexture(GL_TEXTURE_2D,(unsigned int)texture->texture[0]);
		glBegin(GL_QUADS);
		glNormal3f(0.0f,0.0f,1.0f);
		glTexCoord2f(0.0f,0.0f);glVertex3f(posX,posY,posZ);
		glTexCoord2f(1.0f,0.0f);glVertex3f(posX+width,posY,posZ);
		glTexCoord2f(1.0f,1.0f);glVertex3f(posX+width,posY-height,posZ);
		glTexCoord2f(0.0f,1.0f);glVertex3f(posX,posY-height,posZ);
	glEnd();
	for(int a=0;a<count_sliders;a++)
	{
		sliders[a]->draw();
	}
	for(a=0;a<count_buttons;a++)
	{
		buttons[a]->draw();
	}
	for(a=0;a<count_messages;a++)
	{
		if(messages[a]->visible==true)messages[a]->draw();
	}

}
void flat_menu::unclick()
{
	for(int a=0;a<count_sliders;a++)
	{
		slider_moved[a]=false;
	}
	for( a=0;a<count_buttons;a++)
	{
		buttons[a]->clicked=false;
		button_clicked[a]=false;
	}
}

#endif