#include <windows.h>
#include <gl/gl.h>
#include <gl/glaux.h>
#include <gl/glu.h>
#include <math.h>
#include <cstringt.h>
#include <cstringt.h>
#include <atlstr.h>
#include <stdio.h>
#include <time.h>
#include <stdarg.h>
#include <Windowsx.h>
#include <olectl.h>
class models
{

public:
	int First;
	int count;
	int model[999];
	models();
	models(int first);
	void load_model(char*filename,bool to_binary);
	void load_model_binary(char *filename);
	~models();
	void unload();
};
void models::unload()
{
	int a;
	glDeleteLists(model[0],999);
	for(a=0;a<count;a++)model[a]=0;
	count=0;
	First=1;
}
models::~models()
{
	glDeleteLists(model[0],count);
}
models::models()
{
	First=count=0;
}
models::models(int first)
{
	First=first;
	count=0;
}
void models:: load_model_binary(char *filename)
{
	char buf[100];
	char b1[30],b2[30],b3[30];
	char *stop;
	FILE *fil;
	int vertex,normal,face,texture;
	GLfloat vert[50000],norm[50000],text[50000];
	int fac[50000],textn[50000];
	int a;
	int vertexs=0,normals=0,faces=0,textures=0;
	if(fil=fopen(filename,"rb"))
	{
		
		fread(&vertex,sizeof(int),1,fil);
		fread(&normal,sizeof(int),1,fil);
		fread(&face,sizeof(int),1,fil);
		fread(&texture,sizeof(int),1,fil);

		if(vertex)
		{	
			fread(&vertexs,sizeof(int),1,fil);
			fread(&vert,sizeof(GLfloat),vertexs*3,fil);
		}
		if(normal)
		{	
			fread(&normals,sizeof(int),1,fil);
			fread(&norm,sizeof(GLfloat),vertexs*3,fil);
		}
		if(face)
		{	
			fread(&faces,sizeof(int),1,fil);
			fread(&fac,sizeof(GLfloat),faces*3,fil);
		}
		if(texture)
		{	
			fread(&textures,sizeof(int),1,fil);
			fread(&text,sizeof(GLfloat),textures*3,fil);
			fread(&textn,sizeof(GLfloat),faces*3,fil);
		}

		glNewList(First+count,GL_COMPILE);
		
		for(a=0;a<faces*3;a+=3)
		{

			glBegin(GL_TRIANGLES);	
			if(face==1) {
				glNormal3f(norm[(fac[a])*3],norm[((fac[a])*3+1)],norm[((fac[a])*3+2)]);
				glTexCoord2f(text[textn[a]*3],text[textn[a]*3+1]);
				glVertex3f(vert[(fac[a])*3],vert[(fac[a]*3+1)]  ,vert[(fac[a]*3+2)]);	
					
				glNormal3f(norm[(fac[a+1])*3],norm[((fac[a+1])*3+1)],norm[((fac[a+1])*3+2)]);
				glTexCoord2f(text[textn[a+1]*3],text[textn[a+1]*3+1]);
				glVertex3f(vert[fac[a+1]*3],vert[(fac[a+1]*3+1)],vert[(fac[a+1]*3+2)]);	
				
				glNormal3f(norm[(fac[a+2])*3], norm[((fac[a+2])*3+1)],norm[((fac[a+2])*3+2)]);
				glTexCoord2f(text[textn[a+2]*3],text[textn[a+2]*3+1]);
				glVertex3f(vert[fac[a+2]*3],vert[(fac[a+2]*3+1)],vert[(fac[a+2]*3+2)]);	
				}
			glEnd();
		}
		
		glEndList();

		fclose(fil);
		model[count]=First+count;
		count++;

	}
}
void models::load_model(char*filename,bool to_binary)
{
	char buf[100];
	char b1[30],b2[30],b3[30];
	char *stop;
	FILE *fil;
	int vertex,normal,face,texture;
	GLfloat vert[50000],norm[50000],text[50000];
	int fac[50000],textn[50000];
	int a;
	int vertexs=0,normals=0,faces=0,textures=0;
	if(fil=fopen(filename,"rb"))
	{
		fscanf(fil,"%d %d %d %d\n",&vertex,&normal,&face,&texture);
		if(vertex==1)
		{
			fscanf(fil,"%d ",&vertexs);
		}
		if(normal==1)
		{
			normals=vertexs;
		}
		if(face==1)
		{
			fscanf(fil,"%d ",&faces);
		}
		if(texture==1)
		{
			fscanf(fil,"%d ",&textures);
		}
		if(normal!=1)fscanf(fil,"\n",&a);
		if(face!=1)fscanf(fil,"\n",&a);
		if(vertex!=1)fscanf(fil,"\n",&a);
		if(texture!=1)fscanf(fil,"\n",&a);
		fscanf(fil,"\n%s\n",b1);
		if(vertex==1)
		{
			for(a=0;a<vertexs*3;a+=3)
			{
				fscanf(fil,"%s %s %s\n",b1,b2,b3);
				vert[a]=strtod(b1,&stop);
				vert[a+1]=strtod(b2,&stop);
				vert[a+2]=strtod(b3,&stop);
			}
			fscanf(fil,"\n");
			fscanf(fil,"\n%s\n",b1);
		}
		
		if(normal==1)
		{
			for(a=0;a<vertexs*3;a+=3)
			{
				fscanf(fil,"%s %s %s\n",b1,b2,b3);
				norm[a]=strtod(b1,&stop);
				norm[a+1]=strtod(b2,&stop);
				norm[a+2]=strtod(b3,&stop);
			}
			fscanf(fil,"\n");
			fscanf(fil,"\n%s\n",b1);
		}
		if(face==1)
		{
			for(a=0;a<faces*3;a+=3)
			{
				fscanf(fil,"%d %d %d\n",&fac[a],&fac[a+1],&fac[a+2]);
			}
			fscanf(fil,"\n");
			fscanf(fil,"\n%s\n",b1);
		}
		if(texture==1)
		{
			for(a=0;a<textures*3;a+=3)
			{
				fscanf(fil,"%s %s %s\n",b1,b2,b3);
				text[a]=strtod(b1,&stop);
				text[a+1]=strtod(b2,&stop);
				text[a+2]=strtod(b3,&stop);
			}
			fscanf(fil,"\n");

			fscanf(fil,"\n%s\n",b1);
			for(a=0;a<faces*3;a+=3)
			{
				fscanf(fil,"%d %d %d\n",&textn[a],&textn[a+1],&textn[a+2]);
	
			}
			fscanf(fil,"\n");
			fscanf(fil,"\n%s\n",b1);
		}
		glNewList(First+count,GL_COMPILE);
		
		for(a=0;a<faces*3;a+=3)
		{

			glBegin(GL_TRIANGLES);	
			if(face==1) {
				if(normal==1)glNormal3f( (norm[(fac[a])*3]+norm[(fac[a+1])*3]+norm[(fac[a+2])*3])/3, (norm[((fac[a])*3+1)]+norm[((fac[a+1])*3+1)]+norm[((fac[a+2])*3+1)])/3,(norm[((fac[a])*3+2)]+norm[((fac[a+1])*3+2)]+norm[((fac[a+2])*3+2)])/3);
				glTexCoord2f(text[textn[a]*3],text[textn[a]*3+1]);
				glVertex3f(vert[(fac[a])*3],vert[(fac[a]*3+1)]  ,vert[(fac[a]*3+2)]);	
					
				glTexCoord2f(text[textn[a+1]*3],text[textn[a+1]*3+1]);
				glVertex3f(vert[fac[a+1]*3],vert[(fac[a+1]*3+1)],vert[(fac[a+1]*3+2)]);	
				
				glTexCoord2f(text[textn[a+2]*3],text[textn[a+2]*3+1]);
				glVertex3f(vert[fac[a+2]*3],vert[(fac[a+2]*3+1)],vert[(fac[a+2]*3+2)]);	
				}
			glEnd();
		}
		
		glEndList();

		fclose(fil);
		count++;
		if(to_binary)
		{
			sprintf(buf,"%sb",filename);
		fil=fopen(buf,"wb");
		fwrite(&vertex,sizeof(int),1,fil);
		fwrite(&normal,sizeof(int),1,fil);
		fwrite(&face,sizeof(int),1,fil);
		fwrite(&texture,sizeof(int),1,fil);

		if(vertex)
		{	
			fwrite(&vertexs,sizeof(int),1,fil);
			fwrite(&vert,sizeof(GLfloat),vertexs*3,fil);
		}
		if(normal)
		{	
			fwrite(&normals,sizeof(int),1,fil);
			fwrite(&norm,sizeof(GLfloat),vertexs*3,fil);
		}
		if(face)
		{	
			fwrite(&faces,sizeof(int),1,fil);
			fwrite(&fac,sizeof(GLfloat),faces*3,fil);
		}
		if(texture)
		{	
			fwrite(&textures,sizeof(int),1,fil);
			fwrite(&text,sizeof(GLfloat),textures*3,fil);
			fwrite(&textn,sizeof(GLfloat),faces*3,fil);
		}

		fclose(fil);
		}
	}

}
