#include <conio.h>
#include <stdlib.h>
#include <stdio.h>			
#include <iostream>		
// 
#include <al.h>
#include <alc.h>
#include <alut.h>	
//  
class sound
{
	ALfloat listener_pos[3];
	ALfloat source_pos[3];
	//
	ALfloat listener_vel[3];
	ALfloat source_vel[3];
	ALfloat listener_ori[3];

	ALuint Buffer[100];
	ALuint Source[100];
	int count;
public:

	//---------------
	ALboolean open(char *filename,int loop);
	void set_listener_pos(ALfloat x,ALfloat y,ALfloat z);
	void set_listener_vel(ALfloat x,ALfloat y,ALfloat z);
	void set_listener_ori(ALfloat x,ALfloat y,ALfloat z);
	//*************************************************
	void move(ALfloat x,ALfloat y,ALfloat z,int number);
	void play(int number);
	void stop(int number);
	void pause(int number);



	//*************************************************
	~sound();
	void kill();
	sound();
};
sound::~sound()
{
	kill();
}
sound::sound()
{
	count=0;
	listener_pos[0]=0;
	listener_pos[1]=0;
	listener_pos[2]=0;

	listener_ori[0]=0;
	listener_ori[1]=0;
	listener_ori[2]=0;

	listener_vel[0]=0;
	listener_vel[1]=0;
	listener_vel[2]=0;

	source_pos[0]=0;
	source_pos[1]=0;
	source_pos[2]=0;

	source_vel[0]=0;
	source_vel[1]=0;
	source_vel[2]=0;

}
ALboolean  sound::open(char *filename, int loop)
{
	
	ALenum format;
	ALsizei size;
	ALvoid* data;
	ALsizei freq;
	
	// Load wav data into a buffer.

	alGenBuffers(1, &Buffer[count]);
	ALboolean Z;
	if(alGetError() != AL_NO_ERROR)
		return AL_FALSE;
	if(loop==1)	alutLoadWAVFile(filename, &format, &data, &size, &freq, &Z);
	else 	alutLoadWAVFile(filename, &format, &data, &size, &freq, AL_FALSE);
	alBufferData(Buffer[count], format, data, size, freq);
	alutUnloadWAV(format, data, size, freq);
	// Bind the buffer with the source.
	alGenSources(1, &Source[count]);

	if(alGetError() != AL_NO_ERROR)
		return AL_FALSE;

	alSourcei (Source[count], AL_BUFFER,   Buffer[count]   );
	alSourcef (Source[count], AL_PITCH,    1.0      );
	alSourcef (Source[count], AL_GAIN,     1.0      );
	alSourcefv(Source[count], AL_POSITION, source_pos);
	alSourcefv(Source[count], AL_VELOCITY, source_vel);

	if(loop==1)	alSourcei (Source[count], AL_LOOPING, AL_TRUE  );
	else alSourcei (Source[count], AL_LOOPING, AL_FALSE  );

	// Do another error check and return.
	count++;
	if(alGetError() == AL_NO_ERROR)
		return AL_TRUE;

	return AL_FALSE;

}


void sound::set_listener_pos(ALfloat x,ALfloat y,ALfloat z)
{
	listener_pos[0]=x;
	listener_pos[1]=y;
	listener_pos[2]=z;
	alListenerfv(AL_POSITION,    listener_pos);
}
void sound::set_listener_vel(ALfloat x,ALfloat y,ALfloat z)
{
	listener_vel[0]=x;
	listener_vel[1]=y;
	listener_vel[2]=z;
	alListenerfv(AL_VELOCITY,    listener_pos);
}
void sound::set_listener_ori(ALfloat x,ALfloat y,ALfloat z)
{
	listener_ori[0]=x;
	listener_ori[1]=y;
	listener_ori[2]=z;
	alListenerfv(AL_ORIENTATION,    listener_pos);
}
void sound::kill()
{
	int a;
	for(a=0;a<count;a++)
	{
		alDeleteBuffers(1, &Buffer[a]);
		alDeleteSources(1, &Source[a]);
	}
	alutExit();

}
void sound::move(ALfloat x,ALfloat y,ALfloat z,int number)

{
	source_pos[0]=x;
	source_pos[1]=y;
	source_pos[2]=z;
	alSourcefv(Source[number], AL_POSITION, source_pos);
}
void sound::play(int number)
{
	alSourcePlay(Source[number]);
}
void sound::stop(int number)
{
	alSourceStop(Source[number]);
}
void sound::pause(int number)
{
	alSourcePause(Source[number]);
}

